// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 5 abril 2016
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// ADMV AdornoDecorativoMolinoViento
// El archivo dibuja un reloj de adorno con forma de molino de viento. 
// La figura original fue disenada en su totalidad con el programa Moray
// y luego se modifico ligeramente para adaptarla al sistema de macros POV-Ray.
// Es muy poco flexible. Es compatible con POVRay 3.1.
//
// La macro principal tiene tres parametros. 
// #macro ADMV_AdornoMolino( AnguloAspa, AnguloHorario, AnguloMinutero )       
//      AnguloAspa              : Angulo para girar las aspas del molino.
//              La posicion cero es horizontal.
//      AnguloHorario           : Angulo para girar el horario desde las doce.
//      AnguloMinutero          : Angulo para girar el minutero desde cero.
//
// La siguiente macro permite modificar las texturas desde los parametros.
// #macro ADMV_AdornoDecorativoMolinoViento
//        ( AnguloAspa, AnguloHorario, AnguloMinutero,
//          MaterialPrincipal, MaterialTecho,
//          MaterialAspa, MaterialBase, MaterialMetalizado,
//          MaterialBateria, MaterialVidrio, MaterialDorado,
//          MaterialLetra )
//      AnguloAspa              : Angulo para girar las aspas del molino.
//              La posicion cero es horizontal.
//      AnguloHorario           : Angulo para girar el horario desde las doce.
//      AnguloMinutero          : Angulo para girar el minutero desde cero.
//      MaterialPrincipal       : Material para aplicar al cuerpo principal.
//              Valor por defecto ADMV_MaterialPrincipal. 
//      MaterialTecho           : Material para aplicar al techo.
//              Valor por defecto ADMV_MaterialTecho.
//      MaterialAspa            : Material para aplicar a las aspas y otros elementos.
//              Valor por defecto ADMV_MaterialAspa. 
//      MaterialBase            : Material para la base del adorno.
//              Valor por defecto ADMV_MaterialBase.
//      MaterialMetalizado      : Material para el fondo del reloj.
//              Valor por defecto ADMV_MaterialMetalizado.
//      MaterialBateria         : Material para aplicar al cierre del compartimento
//              para baterias. Valor por defecto ADMV_MaterialBateria.
//      MaterialVidrio          : Material para el vidrio de la caratula del reloj.
//              Valor por defecto ADMV_MaterialVidrio.
//      MaterialDorado          : Material para algunos elementos decorativos.
//              Valor por defecto ADMV_MaterialDorado.
//      MaterialLetra           : Material para numeros y otros simbolos del reloj.
//              Valor por defecto ADMV_MaterialLetra.
//  
// El adorno se encuentra completamente contenido en las siguientes coordenadas.
//      Minimo  = <-105,   0, -65 >*L
//      Maximo  = < 105, 270,  65 >*L  
// Frente mira hacia Z-, gravedad Y-. La figura se ubica casi centrada sobre
// el plano XZ.
//
// Estas son variables predefinidas o generadas en el
// interna de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare ADMV_DefaultMaterialPrincipal       
//      Material para aplicar al cuerpo principal.
// #declare ADMV_DefaultMaterialTecho            
//      Material para aplicar al techo.
// #declare ADMV_DefaultMaterialAspa            
//      Material para aplicar a las aspas y otros elementos.   
// #declare ADMV_DefaultMaterialBase
//      Material para la base del adorno.
// #declare ADMV_DefaultMaterialMetalizado      
//      Material para el fondo del reloj.
// #declare ADMV_DefaultMaterialBateria         
//      Material para aplicar al cierre del compartimento para baterias. 
// #declare ADMV_DefaultMaterialVidrio          
//      Material para el vidrio de la caratula del reloj.
// #declare ADMV_DefaultMaterialDorado          
//      Material para algunos elementos decorativos.
// #declare ADMV_DefaultMaterialLetra           
//      Material para numeros y otros simbolos del reloj.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare ADMV_MaterialPrincipal                      = material { ... }      
//      Material para aplicar al cuerpo principal.
// #declare ADMV_MaterialTecho                          = material { ... }        
//      Material para aplicar al techo.
// #declare ADMV_MaterialAspa                           = material { ... }       
//      Material para aplicar a las aspas y otros elementos.                 
// #declare ADMV_MaterialBase                           = material { ... }
//      Material para la base del adorno.
// #declare ADMV_MaterialMetalizado                     = material { ... }   
//      Material para el fondo del reloj.
// #declare ADMV_MaterialBateria                        = material { ... }        
//      Material para aplicar al cierre del compartimento para baterias. 
// #declare ADMV_MaterialVidrio                         = material { ... }       
//      Material para el vidrio de la caratula del reloj.
// #declare ADMV_MaterialDorado                         = material { ... }  
//      Material para algunos elementos decorativos.
// #declare ADMV_MaterialLetra                          = material { ... }   
//      Material para numeros y otros simbolos del reloj.
//        
// Para colocarlo simplemente
// #include "ADMV.inc" 
// object { ADMV_AdornoMolino(0,0,0)
//                                  
// Ejemplo con la macro de texturas, mismo objeto default
// #include "ADMV.inc"   
// object                       {
//   ADMV_AdornoDecorativoMolinoViento(0,0,0,
//          ADMV_MaterialPrincipal, ADMV_MaterialTecho,
//          ADMV_MaterialAspa, ADMV_MaterialBase,
//          ADMV_MaterialMetalizado, ADMV_MaterialBateria,
//          ADMV_MaterialVidrio, ADMV_MaterialDorado,
//          ADMV_MaterialLetra )
// }
//        
// Con modificadores
// #include "ADMV.inc"
// #include "textures.inc"
// #declare ADMV_MaterialPrincipal   = material { texture { PinkAlabaster } }
// object        { ADMV_MolinoViento(0,0,0) }
//      

#declare ADMV_L                 = 0.001;  
  
#if ( version < 3.2 )
  #ifndef( ADMV_POV3_1 )
    #declare ADMV_POV3_1        = on;
  #end
#else
  #ifndef( ADMV_POV3_1 )
    #declare ADMV_POV3_1        = off;
  #end
#end

#declare ADMV_DefaultMaterialPrincipal =
   material  // ADMV_MaterialPrincipal
   {   
      texture
      {      
         pigment
         {
            spotted
            pigment_map
            {
               [0.0   
                  color rgb <1.0, 1.0, 0.501961>
               ]
               [0.695833
                  color rgb <1.0, 1.0, 0.043137>
               ]
               [0.975 
                  color rgb <1.0, 1.0, 0.0>
               ]
               [1.0   
                  color rgb <1.0, 0.70995, 0.266667>
               ]
            }
            turbulence 0.5
            ramp_wave
         }      
         normal
         {
            bumps , 1.0
         }      
         finish
         {
            ambient 0.3
            diffuse 0.5
            brilliance 0.776667
            phong 0.8349
            phong_size 38.39
         }
      }
   }

#ifndef ( ADMV_MaterialPrincipal )
  #declare ADMV_MaterialPrincipal        = ADMV_DefaultMaterialPrincipal
#end  // #ifndef ( ADMV_MaterialPrincipal )

#declare ADMV_DefaultMaterialTecho =
   material  // ADMV_TexturaTecho
   {   
      texture
      {      
         pigment
         {
            #if ( ADMV_POV3_1 )
              crackle
            #else
              crackle form <-1.0, 1.0, 0.0>
            #end
            color_map
            {
               [ 0.0     rgbft <0.25098, 0.0, 0.0, 0.0, 0.0> ]
               [ 1.0     rgbft <0.501961, 0.25098, 0.25098, 0.0, 0.0> ]
            }
         }      
         normal
         {
            checker
            scale  0.2
            rotate -45.0 * x
         }
      }
   }

#ifndef ( ADMV_MaterialTecho )
  #declare ADMV_MaterialTecho   = ADMV_DefaultMaterialTecho
#end  // #ifndef ( ADMV_MaterialTecho )

#declare ADMV_DefaultMaterialAspa =
   material  // ADMV_TexturaAspa
   {   
      texture
      {      
         pigment
         {
            ripples
            color_map
            {
               [ 0.0     rgbft <0.25098, 0.0, 0.0, 0.0, 0.0> ]
               [ 1.0     rgbft <0.501961, 0.25098, 0.25098, 0.0, 0.0> ]
            }
            turbulence 1.0
            ramp_wave
         }      
         normal
         {
            bumps , 0.5
         }
      }
   }

#ifndef ( ADMV_MaterialAspa )
  #declare ADMV_MaterialAspa    = ADMV_DefaultMaterialAspa
#end

#declare ADMV_DefaultMaterialBase =
   material             {
   texture  // txt_399
   {   
      pigment
      {
         granite
         color_map
         {
            [ 0.0     rgbft <0.12, 0.12, 0.12, 0.0, 0.0> ]
            [ 0.9     rgbft <0.12, 0.22, 0.12, 0.0, 0.0> ]
            [ 0.95    rgbft <0.45, 0.58, 0.48, 0.0, 0.0> ]
            [ 1.0     rgbft <0.45, 0.58, 0.48, 0.0, 0.0> ]
         }
         scale  <2.0, 4.0, 2.0>
         rotate    <30.0, 0.0, 50.0>
      }   
      finish
      {
         ambient 0.2
         diffuse 0.9
      }
   }
   texture  // txt_400
   {   
      pigment
      {
         granite
         color_map
         {
            [ 0.0     rgbft <0.4, 0.48, 0.42, 0.0, 0.0> ]
            [ 0.3     rgbft <1.0, 1.0, 1.0, 0.7, 0.0> ]
            [ 1.0     rgbft <1.0, 1.0, 1.0, 1.0, 0.0> ]
         }
         scale  <1.5, 2.2, 1.4>
         rotate    <330.0, 0.0, 50.0>
      }   
      normal
      {
         wrinkles , 0.3
         scale  0.2
      }   
      finish
      {
         ambient 0.1
         phong 0.9
         phong_size 90.0
      }
   }
 }

#ifndef ( ADMV_MaterialBase )
  #declare ADMV_MaterialBase    = ADMV_DefaultMaterialBase
#end  // #ifndef ( ADMV_MaterialBase )

#declare ADMV_DefaultMaterialMetalizado =
   material  //
   {   
      texture
      {      
         pigment
         {
            color rgb <0.55, 0.5, 0.45>
         }      
         finish
         {
            ambient 0.1
            diffuse 0.65
            brilliance 1.5
            specular 0.85
            roughness 0.01
            #if ( ADMV_POV3_1 )
              reflection
            #else
              reflection
              {
                 0.45 , 0.45
                 fresnel  off
                 falloff  1.0
                 exponent 1.0
                 metallic 0.0
              }
            #end
         }
      }
   }

#ifndef ( ADMV_MaterialMetalizado )
  #declare ADMV_MaterialMetalizado      = ADMV_DefaultMaterialMetalizado
#end  // #ifndef ( ADMV_MaterialMetalizado )

#declare ADMV_DefaultMaterialBateria =
   material  // ADMV_TexturaBateria
   {   
      texture
      {
         gradient <0.0, 1.0, 1.0>
         texture_map
         {
            [0.0   
               pigment
               {
                  spotted
                  pigment_map
                  {
                     [0.0   
                        color rgb <1.0, 1.0, 0.501961>
                     ]
                     [0.695833
                        color rgb <1.0, 1.0, 0.043137>
                     ]
                     [0.975 
                        color rgb <1.0, 1.0, 0.0>
                     ]
                     [1.0   
                        color rgb <1.0, 0.70995, 0.266667>
                     ]
                  }
                  turbulence 0.5
                  ramp_wave
               }               
               normal
               {
                  bumps , 1.0
               }               
               finish
               {
                  ambient 0.3
                  diffuse 0.5
                  brilliance 0.776667
                  phong 0.8349
                  phong_size 38.39
               }
            ]
            [0.908333
               pigment
               {
                  spotted
                  pigment_map
                  {
                     [0.0   
                        color rgb <1.0, 1.0, 0.501961>
                     ]
                     [0.695833
                        color rgb <1.0, 1.0, 0.043137>
                     ]
                     [0.975 
                        color rgb <1.0, 1.0, 0.0>
                     ]
                     [1.0   
                        color rgb <1.0, 0.70995, 0.266667>
                     ]
                  }
                  turbulence 0.5
                  ramp_wave
               }               
               normal
               {
                  bumps , 1.0
               }               
               finish
               {
                  ambient 0.3
                  diffuse 0.5
                  brilliance 0.776667
                  phong 0.8349
                  phong_size 38.39
               }
            ]
            [1.0   
               pigment
               {
                  color rgb <0.25098, 0.0, 0.0>
               }
            ]

         }
         scale  0.05
      }
   }

#ifndef ( ADMV_MaterialBateria )
  #declare ADMV_MaterialBateria      =
                ADMV_DefaultMaterialBateria
#end  // #ifndef ( ADMV_MaterialBateria )

#declare ADMV_DefaultMaterialVidrio =
   material  //
   {   
      texture
      {      
         pigment
         {
            color rgbf <1.0, 1.0, 1.0, 0.85>
         }      
         finish
         {
            ambient 0.05
            diffuse 0.4
            specular 0.2
            roughness 0.001
            #if ( ADMV_POV3_1 )
              reflection
            #else
              reflection
              {
                 0.1 , 0.1
                 fresnel  off
                 falloff  1.0
                 exponent 1.0
                 metallic 0.0
              }
            #end
         }
      }   
      interior
      {
         ior 1.5
      }
   }

#ifndef ( ADMV_MaterialVidrio )
  #declare ADMV_MaterialVidrio  = ADMV_DefaultMaterialVidrio
#end  // #ifndef ( ADMV_MaterialVidrio )

#declare ADMV_DefaultMaterialDorado =
   material  //
   {   
      texture
      {      
         pigment
         {
            color rgb <0.5, 0.35, 0.25>
         }      
         finish
         {
            ambient 0.1
            diffuse 0.65
            brilliance 0.5
            specular 0.85
            roughness 0.1
            #if ( ADMV_POV3_1 )
              reflection
            #else
              reflection
              {
                 0.45 , 0.45
                 fresnel  off
                 falloff  1.0
                 exponent 1.0
                 metallic 0.0
              }
            #end
         }
      }
   }

#ifndef ( ADMV_MaterialDorado )
  #declare ADMV_MaterialDorado  = ADMV_DefaultMaterialDorado
#end  // #ifndef ( ADMV_MaterialDorado )

#declare ADMV_DefaultMaterialLetra =
   material  // ADMV_TexturaLetra
   {   
      texture
      {      
         pigment
         {
            color rgb <0.25098, 0.0, 0.0>
         }
      }
   }

#ifndef ( ADMV_MaterialLetra )
  #declare ADMV_MaterialLetra   = ADMV_DefaultMaterialLetra
#end  // #ifndef ( ADMV_MaterialLetra )


#macro ADMV_Aspa001( MaterialAspa )
union {
  box { // ADMV_Cube005
    <-1, -1, -1>, <1, 1, 1>
    scale <2.0, 0.15, 0.15>
    translate  2.25*x
  }
  box { // ADMV_Cube006
    <-1, -1, -1>, <1, 1, 1>
    scale <1.8, 0.05, 0.05>
    translate  <2.4, 0.0, 0.3>
  }
  box { // ADMV_Cube007
    <-1, -1, -1>, <1, 1, 1>
    scale <1.8, 0.05, 0.05>
    rotate -1.0*y
    translate  <2.4, 0.0, 0.525>
  }
  box { // ADMV_Cube008
    <-1, -1, -1>, <1, 1, 1>
    scale <1.8, 0.05, 0.05>
    rotate -2.0*y
    translate  <2.4, 0.0, 0.75>
  }
  box { // ADMV_Cube009
    <-1, -1, -1>, <1, 1, 1>
    scale <0.05, 0.05, 0.5>
    translate  <4.24401, 0.0, 0.391594>
  }
  box { // ADMV_Cube010
    <-1, -1, -1>, <1, 1, 1>
    scale <0.05, 0.05, 0.4>
    rotate 5.0*y
    translate  <0.52234, 0.0, 0.391594>
  }
  box { // ADMV_Cube011
    <-1, -1, -1>, <1, 1, 1>
    scale <0.05, 0.05, 0.4>
    rotate 4.0*y
    translate  <1.175264, 0.0, 0.326301>
  }
  box { // ADMV_Cube012
    <-1, -1, -1>, <1, 1, 1>
    scale <0.05, 0.05, 0.42>
    translate  <2.024066, 0.0, 0.326301>
  }
  box { // ADMV_Cube013
    <-1, -1, -1>, <1, 1, 1>
    scale <0.05, 0.05, 0.4>
    rotate 4.0*y
    translate  <2.709637, 0.0, 0.456886>
  }
  box { // ADMV_Cube014
    <-1, -1, -1>, <1, 1, 1>
    scale <0.05, 0.05, 0.4>
    rotate 4.0*y
    translate  <3.558439, 0.0, 0.358947>
  }
  material {
    MaterialAspa
  }
  scale <1.02, 1.0, 1.2>
  rotate <-2.0, 0, 0.0>
  translate  -2.0*y
}
#end
#declare ADMV_Cube017 = object {
  box { // ADMV_Cube017
    <-1, -1, -1>, <1, 1, 1>
    scale <0.075, 0.075, 0.85>
    rotate 17.166462*x
    translate  <-2.0, -2.506383, -2.859823>
  }
}
#declare ADMV_Cube025 = object {
  box { // ADMV_Cube025
    <-1, -1, -1>, <1, 1, 1>
    scale <0.075, 0.075, 0.85>
    rotate -17.16*y
    translate  <-2.874368, -2.0, -2.82457>
  }
}
#declare ADMV_Cylndr004 = object {
  cylinder { // ADMV_Cylndr004
    <0,0,1>, <0,0,0>, 1 
    scale 0.05
    rotate 90.0*x
    translate  1.2*z
  }
}
#declare ADMV_Cylndr016 = object {
  cylinder { // ADMV_Cylndr016
    <0,0,1>, <0,0,0>, 1 
    scale <0.025, 0.025, 0.05>
    rotate 90.0*x
    translate  1.2*z
  }
}
#declare ADMV_Cube048 = object {
  box { // ADMV_Cube048
    <-1, -1, -1>, <1, 1, 1>
    scale <0.2, 1.0, 0.2>
    translate  -0.75*x
  }
}
#declare ADMV_HileraDiferencia = union {
  object { ADMV_Cube048 }
  object { // ADMV_Cube049 -> ADMV_Cube048
    ADMV_Cube048
    translate  0.5*x
  }
  object { // ADMV_Cube050 -> ADMV_Cube048
    ADMV_Cube048
    translate  1.0*x
  }
  object { // ADMV_Cube051 -> ADMV_Cube048
    ADMV_Cube048
    translate  1.5*x
  }
}




//
// ********  OBJECTS  *******
//

#macro ADMV_Cajita( MaterialBase )
difference {
  box { // ADMV_Cube001
    <-1, -1, -1>, <1, 1, 1>
    scale <2.0, 1.65, 1.2>
    translate  -4.3*z
  }
  box { // ADMV_Cube002
    <-1, -1, -1>, <1, 1, 1>
    scale <1.8, 1.65, 0.2>
    translate  <0.0, -1.7, -5.1>
  }
  material                      {
    MaterialBase
  }
  scale <1.2, 1.2, 0.5>
  translate  -2.5*z
}
#end
#macro ADMV_BaseInferior( MaterialBase )
union {
  object { ADMV_Cajita( MaterialBase ) }
  scale <0.95, 0.95, 1.0>
}
#end
#declare ADMV_DiferenciaSuperiorTechoFrontal = difference {
  superellipsoid { // ADMV_FormaFrontalSuperior1
    <1.3, 0.1>
    scale <1.56, 2.184, 2.08>
    rotate -90.0*x
    translate  1.39*z
  }
  superellipsoid { // ADMV_FormaFrontalSuperior2
    <1.3, 0.1>
    scale <1.5, 2.1, 2.0>
    rotate -90.0*x
    translate  1.4*z
  }
  box { // ADMV_Cube004
    <-1, -1, -1>, <1, 1, 1>
    scale <2.0, 2.2, 1.525>
  }
}
#macro ADMV_InterseccionTechoFrontal( MaterialTecho )
intersection {
  box { // ADMV_Cube003
    <-1, -1, -1>, <1, 1, 1>
    scale <2.0, 1.6, 3.0>
    translate  1.4*z
  }
  object { ADMV_DiferenciaSuperiorTechoFrontal }
  material {
    MaterialTecho
  }
  scale <1.0, 0.9, 1.0>
}
#end
#declare ADMV_DiferenciaInteriorSoporteAsta = difference {
  cylinder { // ADMV_Cylndr081
    <0,0,1>, <0,0,0>, 1 
    scale <0.5, 0.5, 0.3>
    rotate 90.0*x
  }
  box { // ADMV_Cube053
    <-1, -1, -1>, <1, 1, 1>
    translate  -0.9*z
  }
}
#macro ADMV_DecoradoSoporteAspas( MaterialDorado )
difference {
  cylinder { // ADMV_Cylndr080
    <0,0,1>, <0,0,0>, 1 
    scale <0.6, 0.6, 0.2>
    rotate 90.0*x
  }
  box { // ADMV_Cube052
    <-1, -1, -1>, <1, 1, 1>
    translate  -1.0*z
  }
  object { ADMV_DiferenciaInteriorSoporteAsta }
  material {
    MaterialDorado
  }
  translate  -1.1*y
}
#end
#macro ADMV_Aspas( AnguloAspa, MaterialAspa, MaterialDorado )
union {
  union                 {
  cylinder { // ADMV_Cylndr001
    <0,0,1>, <0,0,0>, 1 
    scale <0.15, 0.15, -2.0>
    rotate -90.0*x
  }
  cylinder { // ADMV_Cylndr002
    <0,0,1>, <0,0,0>, 1 
    scale <0.35, 0.35, 0.25>
    rotate 90.0*x
    translate  -1.8*y
  }
  object { ADMV_Aspa001( MaterialAspa ) }
  object { // ADMV_Aspa002 -> ADMV_Aspa001
    ADMV_Aspa001( MaterialAspa )
    rotate <0.0, -90.0, 0.0>
    translate  0.0*z
  }
  object { // ADMV_Aspa003 -> ADMV_Aspa001
    ADMV_Aspa001( MaterialAspa )
    rotate <180.0, 0.0, 180.0>
    translate  -0.0*x
  }
  object { // ADMV_Aspa004 -> ADMV_Aspa001
    ADMV_Aspa001( MaterialAspa )
    rotate 90.0*y
    translate  <-0.0, 0.0, -0.0>
  }
    rotate      -AnguloAspa*y     
  }
  torus { // Torus002
    0.2, 0.1  rotate -x*90
    material {
      MaterialDorado
    }
    rotate -90.0*x
    translate  -1.25*y
  }
  object { ADMV_DecoradoSoporteAspas( MaterialDorado ) }
  material {
    MaterialAspa
  }
  translate  2.0*z
}     
#end  // 
#declare ADMV_TaperSweep017 = prism {
  conic_sweep
  linear_spline
  0.8,1.0
  9  // control points
  <0.9, 1.0>,
  <-0.9, 1.0>,
  <-1.0, 0.9>,
  <-1.0, -0.9>,
  <-0.9, -1.0>,
  <0.9, -1.0>,
  <1.0, -0.9>,
  <1.0, 0.9>,
  <0.9, 1.0>
  rotate <90,0,90>
  scale <3.2, 2.8, 9.0>
  translate  -11.0*z
}
#declare ADMV_TaperSweep018 = prism {
  conic_sweep
  linear_spline
  0.8,1.0
  9  // control points
  <0.9, 1.0>,
  <-0.9, 1.0>,
  <-1.0, 0.9>,
  <-1.0, -0.9>,
  <-0.9, -1.0>,
  <0.9, -1.0>,
  <1.0, -0.9>,
  <1.0, 0.9>,
  <0.9, 1.0>
  rotate <90,0,90>
  scale <3.15, 2.75, 9.0>
  translate  -10.8*z
}
#declare ADMV_DiferenciaPiso = difference {
  object { ADMV_TaperSweep017 }
  box { // ADMV_Cube015
    <-1, -1, -1>, <1, 1, 1>
    scale <4.0, 3.0, 0.35>
    translate  -3.3*z
  }
  box { // ADMV_Cube016
    <-1, -1, -1>, <1, 1, 1>
    scale <4.0, 3.0, 0.35>
    translate  -2.5*z
  }
  object { ADMV_TaperSweep018 }
}
#declare ADMV_Baranda = union {
  object { ADMV_Cube017 }
  object { // ADMV_Cube018 -> ADMV_Cube017
    ADMV_Cube017
    rotate 0.0*x
    translate  <0.8, -0.0, 0.0>
  }
  object { // ADMV_Cube019 -> ADMV_Cube017
    ADMV_Cube017
    rotate 0.0*x
    translate  <1.6, -0.0, 0.0>
  }
  object { // ADMV_Cube020 -> ADMV_Cube017
    ADMV_Cube017
    rotate 0.0*x
    translate  <2.4, -0.0, 0.0>
  }
  object { // ADMV_Cube021 -> ADMV_Cube017
    ADMV_Cube017
    rotate 0.0*x
    translate  <3.2, -0.0, 0.0>
  }
  object { // ADMV_Cube022 -> ADMV_Cube017
    ADMV_Cube017
    rotate 0.0*x
    translate  <4.0, -0.0, 0.0>
  }
  box { // ADMV_Cube023
    <-1, -1, -1>, <1, 1, 1>
    scale <0.075, 0.075, 0.875>
    rotate <22.07926, -17.282162, -11.732901>
    translate  <-2.702955, -2.401526, -2.859823>
  }
  box { // ADMV_Cube024
    <-1, -1, -1>, <1, 1, 1>
    scale <0.075, 0.075, 0.9>
    rotate <16.769634, 12.325181, 8.134288>
    translate  <2.684055, -2.345932, -2.893053>
  }
  object { ADMV_Cube025 }
  object { // ADMV_Cube026 -> ADMV_Cube025
    ADMV_Cube025
    rotate <0.0, 0.0, 0.0>
    translate  <-0.0, 0.8, -0.0>
  }
  object { // ADMV_Cube027 -> ADMV_Cube025
    ADMV_Cube025
    rotate <0.0, 0.0, 0.0>
    translate  <-0.0, 1.6, -0.0>
  }
  object { // ADMV_Cube028 -> ADMV_Cube025
    ADMV_Cube025
    rotate <0.0, 0.0, 0.0>
    translate  <-0.0, 2.4, -0.0>
  }
  object { // ADMV_Cube029 -> ADMV_Cube025
    ADMV_Cube025
    rotate <0.0, 0.0, 0.0>
    translate  <-0.0, 3.2, -0.0>
  }
  object { // ADMV_Cube030 -> ADMV_Cube025
    ADMV_Cube025
    rotate <0.0, 0.0, 0.0>
    translate  <-0.0, 4.0, -0.0>
  }
}
#declare ADMV_Baranda1 = union {
  box { // ADMV_Cube031
    <-1, -1, -1>, <1, 1, 1>
    scale <0.075, 0.075, 0.85>
    rotate 17.166462*x
    translate  <-2.0, -2.506383, -2.859823>
  }
  object { // ADMV_Cube032 -> ADMV_Cube017
    ADMV_Cube017
    rotate 0.0*x
    translate  <0.8, -0.0, 0.0>
  }
  object { // ADMV_Cube033 -> ADMV_Cube017
    ADMV_Cube017
    rotate 0.0*x
    translate  <1.6, -0.0, 0.0>
  }
  object { // ADMV_Cube034 -> ADMV_Cube017
    ADMV_Cube017
    rotate 0.0*x
    translate  <2.4, -0.0, 0.0>
  }
  object { // ADMV_Cube035 -> ADMV_Cube017
    ADMV_Cube017
    rotate 0.0*x
    translate  <3.2, -0.0, 0.0>
  }
  object { // ADMV_Cube036 -> ADMV_Cube017
    ADMV_Cube017
    rotate 0.0*x
    translate  <4.0, -0.0, 0.0>
  }
  box { // ADMV_Cube037
    <-1, -1, -1>, <1, 1, 1>
    scale <0.075, 0.075, 0.875>
    rotate <22.07926, -17.282162, -11.732901>
    translate  <-2.702955, -2.401526, -2.859823>
  }
  box { // ADMV_Cube038
    <-1, -1, -1>, <1, 1, 1>
    scale <0.075, 0.075, 0.9>
    rotate <16.769634, 12.325181, 8.134288>
    translate  <2.684055, -2.345932, -2.893053>
  }
  box { // ADMV_Cube039
    <-1, -1, -1>, <1, 1, 1>
    scale <0.075, 0.075, 0.85>
    rotate -17.16*y
    translate  <-2.874368, -2.0, -2.82457>
  }
  object { // ADMV_Cube040 -> ADMV_Cube025
    ADMV_Cube025
    rotate <0.0, 0.0, 0.0>
    translate  <-0.0, 0.8, -0.0>
  }
  object { // ADMV_Cube041 -> ADMV_Cube025
    ADMV_Cube025
    rotate <0.0, 0.0, 0.0>
    translate  <-0.0, 1.6, -0.0>
  }
  object { // ADMV_Cube042 -> ADMV_Cube025
    ADMV_Cube025
    rotate <0.0, 0.0, 0.0>
    translate  <-0.0, 2.4, -0.0>
  }
  object { // ADMV_Cube043 -> ADMV_Cube025
    ADMV_Cube025
    rotate <0.0, 0.0, 0.0>
    translate  <-0.0, 3.2, -0.0>
  }
  object { // ADMV_Cube044 -> ADMV_Cube025
    ADMV_Cube025
    rotate <0.0, 0.0, 0.0>
    translate  <-0.0, 4.0, -0.0>
  }
  scale <-1.0, -1.0, 1.0>
}
#macro ADMV_Mirador( MaterialAspa )
union {
  object { ADMV_DiferenciaPiso }
  object { ADMV_Baranda }
  object { ADMV_Baranda1 }
  material {
    MaterialAspa
  }
}
#end
#declare ADMV_TaperSweep001 = prism {
  conic_sweep
  linear_spline
  0.75,1.0
  5  // control points
  <-1.0, -1.0>,
  <1.0, -1.0>,
  <1.0, 1.0>,
  <-1.0, 1.0>,
  <-1.0, -1.0>
  rotate <90,0,90>
  scale <3.3, 2.3, -3.4>
  translate  -1.2*z
}
#declare ADMV_TaperSweep002 = prism {
  conic_sweep
  linear_spline
  0.75,1.0
  5  // control points
  <-1.0, -1.0>,
  <1.0, -1.0>,
  <1.0, 1.0>,
  <-1.0, 1.0>,
  <-1.0, -1.0>
  rotate <90,0,90>
  scale <2.85, 2.1, -3.5>
  translate  -0.55*z
}
#declare ADMV_TaperSweep003 = prism {
  conic_sweep
  linear_spline
  0.75,1.0
  5  // control points
  <-1.0, -1.0>,
  <1.0, -1.0>,
  <1.0, 1.0>,
  <-1.0, 1.0>,
  <-1.0, -1.0>
  rotate <90,0,90>
  scale <2.5, 1.8, -3.8>
  translate  0.3*z
}
#declare ADMV_TaperSweep004 = prism {
  conic_sweep
  linear_spline
  0.75,1.0
  5  // control points
  <-1.0, -1.0>,
  <1.0, -1.0>,
  <1.0, 1.0>,
  <-1.0, 1.0>,
  <-1.0, -1.0>
  rotate <90,0,90>
  scale <2.2, 1.7, -4.0>
  translate  1.0*z
}
#declare ADMV_TaperSweep005 = prism {
  conic_sweep
  linear_spline
  0.75,1.0
  5  // control points
  <-1.0, -1.0>,
  <1.0, -1.0>,
  <1.0, 1.0>,
  <-1.0, 1.0>,
  <-1.0, -1.0>
  rotate <90,0,90>
  scale <1.95, 1.6, -5.5>
  translate  3.0*z
}
#declare ADMV_TaperSweep006 = prism {
  conic_sweep
  linear_spline
  0.9,1.0
  5  // control points
  <-1.0, -1.0>,
  <1.0, -1.0>,
  <1.0, 1.0>,
  <-1.0, 1.0>,
  <-1.0, -1.0>
  rotate <90,0,90>
  scale <1.85, 1.55, -9.0>
  translate  7.0*z
}
#declare ADMV_TaperSweep007 = prism {
  conic_sweep
  linear_spline
  0.9,1.0
  5  // control points
  <-1.0, -1.0>,
  <1.0, -1.0>,
  <1.0, 1.0>,
  <-1.0, 1.0>,
  <-1.0, -1.0>
  rotate <90,0,90>
  scale <1.75, 1.5, -9.0>
  translate  7.5*z
}
#declare ADMV_TaperSweep008 = prism {
  conic_sweep
  linear_spline
  0.9,1.0
  5  // control points
  <-1.0, -1.0>,
  <1.0, -1.0>,
  <1.0, 1.0>,
  <-1.0, 1.0>,
  <-1.0, -1.0>
  rotate <90,0,90>
  scale <1.7, 1.45, -9.0>
  translate  8.0*z
}
#declare ADMV_TaperSweep009 = prism {
  conic_sweep
  linear_spline
  0.9,1.0
  5  // control points
  <-1.0, -1.0>,
  <1.0, -1.0>,
  <1.0, 1.0>,
  <-1.0, 1.0>,
  <-1.0, -1.0>
  rotate <90,0,90>
  scale <1.63, 1.38, -9.0>
  translate  8.5*z
}
#declare ADMV_TaperSweep010 = prism {
  conic_sweep
  linear_spline
  0.9,1.0
  5  // control points
  <-1.0, -1.0>,
  <1.0, -1.0>,
  <1.0, 1.0>,
  <-1.0, 1.0>,
  <-1.0, -1.0>
  rotate <90,0,90>
  scale <1.6, 1.37, -9.0>
  translate  9.0*z
}
#declare ADMV_TaperSweep011 = prism {
  conic_sweep
  linear_spline
  0.9,1.0
  5  // control points
  <-1.0, -1.0>,
  <1.0, -1.0>,
  <1.0, 1.0>,
  <-1.0, 1.0>,
  <-1.0, -1.0>
  rotate <90,0,90>
  scale <1.55, 1.35, -9.0>
  translate  9.5*z
}
#declare ADMV_TaperSweep012 = prism {
  conic_sweep
  linear_spline
  0.945,1.0
  5  // control points
  <-1.0, -1.0>,
  <1.0, -1.0>,
  <1.0, 1.0>,
  <-1.0, 1.0>,
  <-1.0, -1.0>
  rotate <90,0,90>
  scale <1.5, 1.3, -9.0>
  translate  10.0*z
}
#declare ADMV_TaperSweep013 = prism {
  conic_sweep
  linear_spline
  0.945,1.0
  5  // control points
  <-1.0, -1.0>,
  <1.0, -1.0>,
  <1.0, 1.0>,
  <-1.0, 1.0>,
  <-1.0, -1.0>
  rotate <90,0,90>
  scale <1.5, 1.3, -9.0>
  translate  10.5*z
}
#declare ADMV_TaperSweep014 = prism {
  conic_sweep
  linear_spline
  0.945,1.0
  5  // control points
  <-1.0, -1.0>,
  <1.0, -1.0>,
  <1.0, 1.0>,
  <-1.0, 1.0>,
  <-1.0, -1.0>
  rotate <90,0,90>
  scale <1.5, 1.3, -9.0>
  translate  11.0*z
}
#declare ADMV_TaperSweep015 = prism {
  conic_sweep
  linear_spline
  0.945,1.0
  5  // control points
  <-1.0, -1.0>,
  <1.0, -1.0>,
  <1.0, 1.0>,
  <-1.0, 1.0>,
  <-1.0, -1.0>
  rotate <90,0,90>
  scale <1.5, 1.3, -9.0>
  translate  11.5*z
}
#declare ADMV_TaperSweep016 = prism {
  conic_sweep
  linear_spline
  0.945,1.0
  5  // control points
  <-1.0, -1.0>,
  <1.0, -1.0>,
  <1.0, 1.0>,
  <-1.0, 1.0>,
  <-1.0, -1.0>
  rotate <90,0,90>
  scale <1.5, 1.3, -9.0>
  translate  12.0*z
}
#declare ADMV_SuperiorParedPrincipal = union {
  object { ADMV_TaperSweep013 }
  object { ADMV_TaperSweep014 }
  object { ADMV_TaperSweep015 }
  object { ADMV_TaperSweep016 }
}
#declare ADMV_FrontalDiferenciaSuperior = intersection {
  object { ADMV_SuperiorParedPrincipal }
  superellipsoid { // ADMV_FormaFrontalSuperior
    <1.3, 0.1>
    scale <1.5, 2.1, 2.0>
    rotate -90.0*x
    translate  1.4*z
  }
}
#declare ADMV_ParedMolino = union {
  object { ADMV_TaperSweep001 }
  object { ADMV_TaperSweep002 }
  object { ADMV_TaperSweep003 }
  object { ADMV_TaperSweep004 }
  object { ADMV_TaperSweep005 }
  object { ADMV_TaperSweep006 }
  object { ADMV_TaperSweep007 }
  object { ADMV_TaperSweep008 }
  object { ADMV_TaperSweep009 }
  object { ADMV_TaperSweep010 }
  object { ADMV_TaperSweep011 }
  object { ADMV_TaperSweep012 }
  object { ADMV_FrontalDiferenciaSuperior }
}
#macro ADMV_ParedPerforada( MaterialMetalizado)
difference {
  object { ADMV_ParedMolino }
  cylinder { // ADMV_Cylndr078
    <0,0,1>, <0,0,0>, 1 
    material {
      MaterialMetalizado
    }
    scale <1.350464, 1.350464, 3.0>
    rotate 90.0*x
    translate  -1.65*z
  }
}
#end
#declare ADMV_UnNumero1 = union {
  text {   // TText002
    #if ( ADMV_POV3_1 )
      ttf "timrom.ttf"
    #else
      ttf "Arial.ttf"
    #end
    "11",
    1.0,  // Depth
    <0.0,     0.0, 0.0> // Offset
    scale 0.3
    rotate 90.0*x
    translate  <-0.086776, 0.0, -0.096417>
  }

  translate  <-0.467625, 0.0, 0.809949>
}
#declare ADMV_UnNumero2 = union {
  text {   // TText003
    #if ( ADMV_POV3_1 )
      ttf "timrom.ttf"
    #else
      ttf "Arial.ttf"
    #end
    "10",
    1.0,  // Depth
    <0.0,     0.0, 0.0> // Offset
    scale 0.3
    rotate 90.0*x
    translate  <-0.086776, 0.0, -0.096417>
  }

  translate  <-0.809949, 0.0, 0.467625>
}
#declare ADMV_UnNumero = union {
  text {   // TText001
    #if ( ADMV_POV3_1 )
      ttf "timrom.ttf"
    #else
      ttf "Arial.ttf"
    #end
    "12",
    1.0,  // Depth
    <0.0,     0.0, 0.0> // Offset
    scale 0.3
    rotate 90.0*x
    translate  <-0.086776, 0.0, -0.096417>
  }

  translate  0.935249*z
}
#declare ADMV_UnNumero5 = union {
  text {   // TText006
    #if ( ADMV_POV3_1 )
      ttf "timrom.ttf"
    #else
      ttf "Arial.ttf"
    #end
    "7",
    1.0,  // Depth
    <0.0,     0.0, 0.0> // Offset
    scale 0.3
    rotate 90.0*x
    translate  <-0.086776, 0.0, -0.096417>
  }

  translate  <-0.467625, 0.0, -0.809949>
}
#declare ADMV_UnNumero3 = union {
  text {   // TText004
    #if ( ADMV_POV3_1 )
      ttf "timrom.ttf"
    #else
      ttf "Arial.ttf"
    #end
    "9",
    1.0,  // Depth
    <0.0,     0.0, 0.0> // Offset
    scale 0.3
    rotate 90.0*x
    translate  <-0.086776, 0.0, -0.096417>
  }

  translate  <-0.935249, 0.0, -0.0>
}
#declare ADMV_UnNumero4 = union {
  text {   // TText005
    #if ( ADMV_POV3_1 )
      ttf "timrom.ttf"
    #else
      ttf "Arial.ttf"
    #end
    "8",
    1.0,  // Depth
    <0.0,     0.0, 0.0> // Offset
    scale 0.3
    rotate 90.0*x
    translate  <-0.086776, 0.0, -0.096417>
  }

  translate  <-0.809949, 0.0, -0.467625>
}
#declare ADMV_UnNumero6 = union {
  text {   // TText007
    #if ( ADMV_POV3_1 )
      ttf "timrom.ttf"
    #else
      ttf "Arial.ttf"
    #end
    "6",
    1.0,  // Depth
    <0.0,     0.0, 0.0> // Offset
    scale 0.3
    rotate 90.0*x
    translate  <-0.086776, 0.0, -0.096417>
  }

  translate  <0.0, 0.0, -0.935249>
}
#declare ADMV_UnNumero7 = union {
  text {   // TText008
    #if ( ADMV_POV3_1 )
      ttf "timrom.ttf"
    #else
      ttf "Arial.ttf"
    #end
    "5",
    1.0,  // Depth
    <0.0,     0.0, 0.0> // Offset
    scale 0.3
    rotate 90.0*x
    translate  <-0.086776, 0.0, -0.096417>
  }

  translate  <0.467625, 0.0, -0.809949>
}
#declare ADMV_UnNumero8 = union {
  text {   // TText009
    #if ( ADMV_POV3_1 )
      ttf "timrom.ttf"
    #else
      ttf "Arial.ttf"
    #end
    "4",
    1.0,  // Depth
    <0.0,     0.0, 0.0> // Offset
    scale 0.3
    rotate 90.0*x
    translate  <-0.086776, 0.0, -0.096417>
  }

  translate  <0.809949, 0.0, -0.467625>
}
#declare ADMV_UnNumero9 = union {
  text {   // TText010
    #if ( ADMV_POV3_1 )
      ttf "timrom.ttf"
    #else
      ttf "Arial.ttf"
    #end
    "3",
    1.0,  // Depth
    <0.0,     0.0, 0.0> // Offset
    scale 0.3
    rotate 90.0*x
    translate  <-0.086776, 0.0, -0.096417>
  }

  translate  <0.935249, 0.0, 0.0>
}
#declare ADMV_UnNumero10 = union {
  text {   // TText011
    #if ( ADMV_POV3_1 )
      ttf "timrom.ttf"
    #else
      ttf "Arial.ttf"
    #end
    "2",
    1.0,  // Depth
    <0.0,     0.0, 0.0> // Offset
    scale 0.3
    rotate 90.0*x
    translate  <-0.086776, 0.0, -0.096417>
  }

  translate  <0.809949, 0.0, 0.467625>
}
#declare ADMV_UnNumero11 = union {
  text {   // TText012
    #if ( ADMV_POV3_1 )
      ttf "timrom.ttf"
    #else
      ttf "Arial.ttf"
    #end
    "1",
    1.0,  // Depth
    <0.0,     0.0, 0.0> // Offset
    scale 0.3
    rotate 90.0*x
    translate  <0.009642, 0.0, -0.077134>
  }

  translate  <0.467625, 0.0, 0.809949>
}
#macro ADMV_TodosNumeros( MaterialLetra )
union {
  object { ADMV_UnNumero1 }
  object { ADMV_UnNumero2 }
  object { ADMV_UnNumero }
  object { ADMV_UnNumero5 }
  object { ADMV_UnNumero3 }
  object { ADMV_UnNumero4 }
  object { ADMV_UnNumero6 }
  object { ADMV_UnNumero7 }
  object { ADMV_UnNumero8 }
  object { ADMV_UnNumero9 }
  object { ADMV_UnNumero10 }
  object { ADMV_UnNumero11 }
  material { MaterialLetra }
  scale <1.0, 0.1, 1.0>
}
#end
#declare ADMV_CincoMinutos = union {
  object { // ADMV_Cylndr015 -> ADMV_Cylndr004
    ADMV_Cylndr004
    rotate 30.0*y
    translate  <-0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr014 -> ADMV_Cylndr004
    ADMV_Cylndr004
    rotate <-0.0, 60.0, 0.0>
    translate  <-0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr013 -> ADMV_Cylndr004
    ADMV_Cylndr004
    rotate 90.0*y
    translate  <-0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr012 -> ADMV_Cylndr004
    ADMV_Cylndr004
    rotate <180.0, 60.0, 180.0>
    translate  0.0*z
  }
  object { // ADMV_Cylndr011 -> ADMV_Cylndr004
    ADMV_Cylndr004
    rotate <-180.0, 30.0, 180.0>
    translate  <0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr010 -> ADMV_Cylndr004
    ADMV_Cylndr004
    rotate <180.0, 0.0, 180.0>
    translate  <0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr009 -> ADMV_Cylndr004
    ADMV_Cylndr004
    rotate <180.0, -30.0, 180.0>
    translate  0.0*x
  }
  object { // ADMV_Cylndr008 -> ADMV_Cylndr004
    ADMV_Cylndr004
    rotate <-180.0, -60.0, 180.0>
    translate  -0.0*z
  }
  object { // ADMV_Cylndr007 -> ADMV_Cylndr004
    ADMV_Cylndr004
    rotate -90.0*y
    translate  -0.0*z
  }
  object { // ADMV_Cylndr006 -> ADMV_Cylndr004
    ADMV_Cylndr004
    rotate <0.0, -60.0, 0.0>
    translate  <-0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr005 -> ADMV_Cylndr004
    ADMV_Cylndr004
    rotate -30.0*y
    translate  -0.0*x
  }
  object { ADMV_Cylndr004 }
  object { ADMV_Cylndr016 }
  object { // ADMV_Cylndr017 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <0.0, -6.0, 0.0>
    translate  0.0*z
  }
  object { // ADMV_Cylndr018 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <0.0, -12.0, 0.0>
  }
  object { // ADMV_Cylndr019 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <-0.0, -18.0, 0.0>
    translate  -0.0*z
  }
  object { // ADMV_Cylndr020 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate -24.0*y
    translate  <0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr021 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate -30.0*y
    translate  -0.0*z
  }
  object { // ADMV_Cylndr022 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <-0.0, -36.0, 0.0>
    translate  <-0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr023 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <-0.0, -42.0, 0.0>
    translate  <0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr024 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <-0.0, -48.0, 0.0>
    translate  <0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr025 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <0.0, -54.0, 0.0>
    translate  <0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr026 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <0.0, -60.0, 0.0>
    translate  <0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr027 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate -66.0*y
    translate  <0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr028 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate -72.0*y
    translate  <0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr029 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <-0.0, -78.0, 0.0>
    translate  0.0*x
  }
  object { // ADMV_Cylndr030 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate -84.0*y
    translate  <0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr031 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate -90.0*y
    translate  <0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr032 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, -84.0, 180.0>
    translate  <0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr033 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, -78.0, 180.0>
    translate  <0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr034 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, -72.0, 180.0>
    translate  <0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr035 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, -66.0, 180.0>
    translate  <0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr036 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <-180.0, -60.0, 180.0>
    translate  <0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr037 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, -54.0, 180.0>
    translate  <0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr038 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, -48.0, 180.0>
    translate  <0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr039 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, -42.0, 180.0>
    translate  <0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr040 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, -36.0, 180.0>
    translate  <0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr041 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, -30.0, 180.0>
    translate  <0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr042 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, -24.0, 180.0>
    translate  <0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr043 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, -18.0, 180.0>
    translate  <0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr044 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, -12.0, 180.0>
    translate  <0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr045 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, -6.0, 180.0>
    translate  <0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr046 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, 0.0, 180.0>
    translate  <-0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr047 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, 6.0, 180.0>
    translate  <-0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr048 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, 12.0, 180.0>
    translate  <-0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr049 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, 18.0, 180.0>
    translate  <-0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr050 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <-180.0, 24.0, 180.0>
    translate  <-0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr051 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <-180.0, 30.0, 180.0>
    translate  <-0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr052 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, 36.0, 180.0>
    translate  <-0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr053 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, 42.0, 180.0>
    translate  <-0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr054 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, 48.0, 180.0>
    translate  <-0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr055 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <-180.0, 54.0, 180.0>
    translate  <-0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr056 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, 60.0, 180.0>
    translate  <-0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr057 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <-180.0, 66.0, 180.0>
    translate  <-0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr058 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, 72.0, 180.0>
    translate  <-0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr059 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, 78.0, 180.0>
    translate  <-0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr060 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <180.0, 84.0, 180.0>
    translate  <-0.0, 0.0, 0.0>
  }
  object { // ADMV_Cylndr061 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate 90.0*y
    translate  <-0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr062 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <-0.0, 84.0, 0.0>
    translate  <-0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr063 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <0.0, 78.0, 0.0>
    translate  <-0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr064 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <0.0, 72.0, 0.0>
    translate  <-0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr065 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate 66.0*y
    translate  <-0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr066 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <-0.0, 60.0, 0.0>
    translate  <-0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr067 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate 54.0*y
    translate  <-0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr068 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <0.0, 48.0, 0.0>
    translate  <-0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr069 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <0.0, 42.0, 0.0>
    translate  <-0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr070 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <-0.0, 36.0, 0.0>
    translate  <-0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr071 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate 30.0*y
    translate  <-0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr072 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <-0.0, 24.0, 0.0>
    translate  <-0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr073 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate 18.0*y
    translate  <-0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr074 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate <-0.0, 12.0, 0.0>
    translate  <-0.0, 0.0, -0.0>
  }
  object { // ADMV_Cylndr075 -> ADMV_Cylndr016
    ADMV_Cylndr016
    rotate 6.0*y
    translate  <0.0, 0.0, -0.0>
  }
}
#macro ADMV_Minutero( AnguloMinutero ) 
union {
  box { // ADMV_Cube045
    <-1, -1, -1>, <1, 1, 1>
    scale <0.4, 0.01, 0.4>
    rotate <-0.0, 45.0, -0.0>
    translate  <0.55, -0.1, -0.055>
  }
  scale <1.0, 1.0, 0.1>
  rotate ( AnguloMinutero-90 )*y
}     
#end
#macro ADMV_Horario( AnguloHorario ) 
union {
  box { // ADMV_Cube046
    <-1, -1, -1>, <1, 1, 1>
    scale <0.4, 0.01, 0.4>
    rotate <-0.0, 45, -0.0>
    translate  <0.55, -0.1, -0.055>
  }
  scale <0.6, 1.0, 0.2>
  rotate ( AnguloHorario-90 )*y
  translate  0.05*z
}       
#end
#macro ADMV_Reloj( AnguloHorario, AnguloMinutero, MaterialDorado,
                MaterialLetra, MaterialMetalizado )
union {
  cylinder { // ADMV_Cylndr003
    <0,0,1>, <0,0,0>, 1 
    scale <1.350464, 1.350464, -0.01>
    rotate 90.0*x
  }
  object { ADMV_TodosNumeros( MaterialLetra ) }
  object { ADMV_CincoMinutos material { MaterialLetra } }
  object { ADMV_Minutero( AnguloMinutero ) material { MaterialLetra } }
  object { 
    ADMV_Horario( AnguloHorario )
    material { MaterialLetra }
  }
  cylinder { // ADMV_Cylndr076
    <0,0,1>, <0,0,0>, 1 
    material {
      MaterialDorado
    }
    scale <0.1, 0.1, 0.2>
    rotate 90.0*x
  }
  cylinder { // ADMV_Cylndr077
    <0,0,1>, <0,0,0>, 1 
    material {
      MaterialDorado
    }
    scale <0.2, 0.2, 0.05>
    rotate 90.0*x
  }
  material {
    MaterialMetalizado
  }     
  scale     <-1,1,1>
  translate  <0.0, -1.0, -1.65>
}    
#end  //
#macro ADMV_CubiertaReloj( MaterialVidrio, MaterialDorado )
union {
  torus { // Torus001
    1.425, 0.125  rotate -x*90
    material {
      MaterialDorado
    }
    rotate -95.0*x
    translate  <0.0, -1.45, -1.65>
  }
  cylinder { // Cylndr079
    <0,0,1>, <0,0,0>, 1 
    material {
      MaterialVidrio
    }
    scale <1.35, 1.35, 0.1>
    rotate -95.0*x
    translate  <0.0, -1.4, -1.65>
  }
}
#end
#macro ADMV_CuadriculaDecorativa( MaterialDorado )
difference {
  box { // ADMV_Cube047
    <-1, -1, -1>, <1, 1, 1>
    scale <1.05, 0.25, 0.8>
  }
  object { ADMV_HileraDiferencia }
  object { // ADMV_HileraDiferencia1 -> ADMV_HileraDiferencia
    ADMV_HileraDiferencia
    translate  0.5*z
  }
  object { // ADMV_HileraDiferencia2 -> ADMV_HileraDiferencia
    ADMV_HileraDiferencia
    translate  -0.5*z
  }
  material {
    MaterialDorado
  }
  rotate -4.0*x
  translate  <0.0, -1.125, 0.8>
}
#end
#macro ADMV_AdornoDecorativoMolinoViento
        ( AnguloAspa, AnguloHorario, AnguloMinutero,
          MaterialPrincipal, MaterialTecho,
          MaterialAspa, MaterialBase, MaterialMetalizado,
          MaterialBateria, MaterialVidrio, MaterialDorado,
          MaterialLetra )
union { // ADMV_AdornoDecorativoMolinoViento
  object { ADMV_BaseInferior( MaterialBase ) }
  object { ADMV_InterseccionTechoFrontal( MaterialTecho ) }
  object { ADMV_Aspas( AnguloAspa, MaterialAspa, MaterialDorado ) }
  object { ADMV_Mirador( MaterialAspa ) }
  object { ADMV_ParedPerforada( MaterialMetalizado ) }
  object { ADMV_Reloj( AnguloHorario, AnguloMinutero,
                        MaterialDorado, MaterialLetra,
                        MaterialMetalizado ) }
  object { ADMV_CubiertaReloj( MaterialVidrio, MaterialDorado ) }
  object { ADMV_CuadriculaDecorativa( MaterialDorado ) }
  cylinder { // ADMV_BotonBateria
    <0,0,1>, <0,0,0>, 1 
    material {
      MaterialBateria
    }
    scale 0.4
    rotate -90.0*y
    translate  1.2*y
  }
  material {
    MaterialPrincipal
  }
  rotate          -90*x   
  rotate          180*y 
  scale             0.1  
  translate         0.525*y
  scale             230*ADMV_L
}
#end  // #ADMV_AdornoDecorativoMolinoViento

#macro ADMV_AdornoMolino( AnguloAspa, AnguloHorario, AnguloMinutero )       
  object                                {
    ADMV_AdornoDecorativoMolinoViento
        ( AnguloAspa, AnguloHorario, AnguloMinutero,
          ADMV_MaterialPrincipal, ADMV_MaterialTecho,
          ADMV_MaterialAspa, ADMV_MaterialBase,
          ADMV_MaterialMetalizado, ADMV_MaterialBateria,
          ADMV_MaterialVidrio, ADMV_MaterialDorado,
          ADMV_MaterialLetra )
  }
#end  // #macro ADMV_AdornoMolino


