// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 5 abril 2016
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// ADMV AdornoDecorativoMolinoViento
// El archivo dibuja un reloj de adorno con forma de molino de viento. 
// La figura original fue disenada en su totalidad con el programa Moray
// y luego se modifico ligeramente para adaptarla al sistema de macros POV-Ray.
// Es muy poco flexible. Es compatible con POVRay 3.1.
//
// La macro principal tiene tres parametros. 
// #macro ADMV_AdornoMolino( AnguloAspa, AnguloHorario, AnguloMinutero )       
//      AnguloAspa              : Angulo para girar las aspas del molino.
//              La posicion cero es horizontal.
//      AnguloHorario           : Angulo para girar el horario desde las doce.
//      AnguloMinutero          : Angulo para girar el minutero desde cero.
//
// La siguiente macro permite modificar las texturas desde los parametros.
// #macro ADMV_AdornoDecorativoMolinoViento
//        ( AnguloAspa, AnguloHorario, AnguloMinutero,
//          MaterialPrincipal, MaterialTecho,
//          MaterialAspa, MaterialBase, MaterialMetalizado,
//          MaterialBateria, MaterialVidrio, MaterialDorado,
//          MaterialLetra )
//      AnguloAspa              : Angulo para girar las aspas del molino.
//              La posicion cero es horizontal.
//      AnguloHorario           : Angulo para girar el horario desde las doce.
//      AnguloMinutero          : Angulo para girar el minutero desde cero.
//      MaterialPrincipal       : Material para aplicar al cuerpo principal.
//              Valor por defecto ADMV_MaterialPrincipal. 
//      MaterialTecho           : Material para aplicar al techo.
//              Valor por defecto ADMV_MaterialTecho.
//      MaterialAspa            : Material para aplicar a las aspas y otros elementos.
//              Valor por defecto ADMV_MaterialAspa. 
//      MaterialBase            : Material para la base del adorno.
//              Valor por defecto ADMV_MaterialBase.
//      MaterialMetalizado      : Material para el fondo del reloj.
//              Valor por defecto ADMV_MaterialMetalizado.
//      MaterialBateria         : Material para aplicar al cierre del compartimento
//              para baterias. Valor por defecto ADMV_MaterialBateria.
//      MaterialVidrio          : Material para el vidrio de la caratula del reloj.
//              Valor por defecto ADMV_MaterialVidrio.
//      MaterialDorado          : Material para algunos elementos decorativos.
//              Valor por defecto ADMV_MaterialDorado.
//      MaterialLetra           : Material para numeros y otros simbolos del reloj.
//              Valor por defecto ADMV_MaterialLetra.
//  
// El adorno se encuentra completamente contenido en las siguientes coordenadas.
//      Minimo  = <-105,   0, -65 >*L
//      Maximo  = < 105, 270,  65 >*L  
// Frente mira hacia Z-, gravedad Y-. La figura se ubica casi centrada sobre
// el plano XZ.
//
// Estas son variables predefinidas o generadas en el
// interna de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare ADMV_DefaultMaterialPrincipal       
//      Material para aplicar al cuerpo principal.
// #declare ADMV_DefaultMaterialTecho            
//      Material para aplicar al techo.
// #declare ADMV_DefaultMaterialAspa            
//      Material para aplicar a las aspas y otros elementos.   
// #declare ADMV_DefaultMaterialBase
//      Material para la base del adorno.
// #declare ADMV_DefaultMaterialMetalizado      
//      Material para el fondo del reloj.
// #declare ADMV_DefaultMaterialBateria         
//      Material para aplicar al cierre del compartimento para baterias. 
// #declare ADMV_DefaultMaterialVidrio          
//      Material para el vidrio de la caratula del reloj.
// #declare ADMV_DefaultMaterialDorado          
//      Material para algunos elementos decorativos.
// #declare ADMV_DefaultMaterialLetra           
//      Material para numeros y otros simbolos del reloj.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare ADMV_MaterialPrincipal                      = material { ... }      
//      Material para aplicar al cuerpo principal.
// #declare ADMV_MaterialTecho                          = material { ... }        
//      Material para aplicar al techo.
// #declare ADMV_MaterialAspa                           = material { ... }       
//      Material para aplicar a las aspas y otros elementos.                 
// #declare ADMV_MaterialBase                           = material { ... }
//      Material para la base del adorno.
// #declare ADMV_MaterialMetalizado                     = material { ... }   
//      Material para el fondo del reloj.
// #declare ADMV_MaterialBateria                        = material { ... }        
//      Material para aplicar al cierre del compartimento para baterias. 
// #declare ADMV_MaterialVidrio                         = material { ... }       
//      Material para el vidrio de la caratula del reloj.
// #declare ADMV_MaterialDorado                         = material { ... }  
//      Material para algunos elementos decorativos.
// #declare ADMV_MaterialLetra                          = material { ... }   
//      Material para numeros y otros simbolos del reloj.
//        
// Para colocarlo simplemente
// #include "ADMV.inc" 
// object { ADMV_AdornoMolino(0,0,0)
//                                  
// Ejemplo con la macro de texturas, mismo objeto default
// #include "ADMV.inc"   
// object                       {
//   ADMV_AdornoDecorativoMolinoViento(0,0,0,
//          ADMV_MaterialPrincipal, ADMV_MaterialTecho,
//          ADMV_MaterialAspa, ADMV_MaterialBase,
//          ADMV_MaterialMetalizado, ADMV_MaterialBateria,
//          ADMV_MaterialVidrio, ADMV_MaterialDorado,
//          ADMV_MaterialLetra )
// }
//        
// Con modificadores
// #include "ADMV.inc"
// #include "textures.inc"
// #declare ADMV_MaterialPrincipal   = material { texture { PinkAlabaster } }
// object        { ADMV_MolinoViento(0,0,0) }
//      
#if ( version >= 3.7 )
  #version 3.7; 
#end

global_settings { assumed_gamma 1.0 }

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}   

#include "ADMV.inc"

#local FactorAcercamiento       = 5;                                   
                                   
object                                  {
  ADMV_AdornoMolino( 20, 45, 90 ) 
  translate         -0.130*y   
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z      
}

