// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 19 abril 2016
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// BEED BicicletaEstacionariaEstiloDejavu
// El archivo dibuja una bicileta estacionaria, similar a las que
// se encuentran actualmente en algunos parques publicos de Costa Rica.
//
// La macro principal tiene tres parametros. 
// #macro BEED_BicicletaEstacionaria( AnguloCiclo, PedalDerecho, PedalIzquierdo )
//      AnguloCiclo             : Angulo para girar el ciclo de rotacion de pedales.
//      PedalDerecho            : Angulo respecto de la horizontal, para el pedal derecho
//          del usuario.
//      PedalIzquierdo          : Angulo respecto de la horizontal, para el pedal izquierdo
//          del usuario.
//
// La siguiente macro permite modificar algunas caracteristicas con mas detalle.
// #macro BEED_BicicletaEstacionariaEstiloDejavu(
//                AnguloCiclo, PedalDerecho, PedalIzquierdo,
//                AltoFundamental, ProfundidadFundamental,
//                SeparacionManivela, LargoPedal,
//                AltoManivela, AltoAsiento,
//                FraccionDelantera, AltoBase,
//                DiametroSoporte, DiametroPrincipal,
//                DiametroAgarradera, DiametroPedal, ArregloTexturas )
//      AnguloCiclo             : Angulo para girar el ciclo de rotacion de pedales.
//      PedalDerecho            : Angulo respecto la horizontal, para el pedal derecho
//          del usuario.
//      PedalIzquierdo          : Angulo respecto la horizontal, para el pedal izquierdo
//          del usuario.  
//      AltoFundamental         : Alto Y principal de referencia para el aparato.
//              Valor por defecto 700*L. 
//      ProfundidadFundamental  : Separacion X entre los ejes de los tubos 
//              frontal y posterior. Valor por defecto 420*L.
//      SeparacionManivela      : Separacion Z entre las dos agarraderas.
//              Valor por defecto 300*L.
//      LargoPedal              : Tamano referencia para dibujar el pedal.
//              Valor por defecto 100*L.
//      AltoManivela            : Altura del punto de apoyo de la manivela.
//              Valor por defecto 560*L.
//      AltoAsiento             : Altura del asiento. Valor por defecto 420*L.
//      FraccionDelantera       : Fraccion de ProfundidadFundamental que se asigna
//              al tubo soporte delantero. Valor por defecto 0.5.
//      AltoBase                : Altura del soporte inferior del aparato.
//              Valor por defecto 140*L.
//      DiametroSoporte         : Diametro del tubo principal de soporte.
//              Valor por defecto 100*L.
//      DiametroPrincipal       : Diametro de los tubos frontal y posterior.
//              Valor por defecto 40*L.
//      DiametroAgaradera       : Diametro del manubrio. Valor por defecto 30*L.
//      DiametroPedal           : Diametro del cilindro de giro soporte de pedales.
//              Valor por defecto 160*L.
//      ArregloTexturas         : Arreglo de cinco texturas
//              { BEED_IndiceTexturaPrincipal, BEED_IndiceTexturaDinamica,
//                BEED_IndiceTexturaSoporte, BEED_IndiceTexturaDecorativa,
//                BEED_IndiceTexturaPedal }. Valor por defecto { BEED_TexturaPrincipal,
//                BEED_TexturaDinamica, BEED_TexturaSoporte, BEED_TexturaDecorativa,
//                BEED_TexturaPedal }. 
//                  BEED_IndiceTexturaPrincipal     : textura principal.
//                  BEED_IndiceTexturaDinamica      : cilindro de giro.
//                  BEED_IndiceTexturaSoporte       : soporte en la base.
//                  BEED_IndiceTexturaDecorativa    : cuero de manivela.
//                  BEED_IndiceTexturaPedal         : pedales.
//              El total de texturas es BEED_TotalTexturas.      
//      
// La bicicleta estacionaria se encuentra completamente contenida
// en las siguientes coordenadas.
//      Minimo  = < -300,    0, -180 >*L
//      Maximo  = <  226,  725,  180 >*L  
// Frente mira hacia X+, gravedad Y-. El cilindro de giro alineado con el origen del
// plano XZ.
//
// Estas son variables predefinidas o generadas en el
// interna de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare BEED_DefaultTexturaPrincipal        
//      Textura principal a aplicar en la estructura.
// #declare BEED_DefaultTexturaDinamica         
//      Textura del eje de giro de los pedales.
// #declare BEED_DefaultTexturaSoporte          
//      Textura de la base inferior.
// #declare BEED_DefaultTexturaDecorativa       
//      Textura para decoracion del cuero de la manivela.
// #declare BEED_DefaultTexturaPedal        
//      Textura de los pedales de la bicicleta.
// #declare BEED_DefaultArregloTexturas
//      Contiene un arreglo con las texturas por defecto sin modificar. 
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare BEED_TexturaPrincipal                   = texture { ... }        
//      Textura principal a aplicar en la estructura.
// #declare BEED_TexturaDinamica                    = texture { ... }         
//      Textura del eje de giro de los pedales.
// #declare BEED_TexturaSoporte                     = texture { ... }
//      Textura de la base inferior.
// #declare BEED_TexturaDecorativa                  = texture { ... }
//      Textura para decoracion del cuero de la manivela.
// #declare BEED_TexturaPedal                       = texture { ... }
//      Textura de los pedales de la bicicleta.
//        
// Para colocarlo simplemente
// #include "BEED.inc" 
// object { BEED_BicicletaEstacionaria(0,0,0)
//                                  
// Ejemplo con la macro detallada, mismo objeto default
// #include "BEED.inc"   
// object                       {
//   BEED_BicicletaEstacionariaEstiloDejavu( 0, 0, 0,
//              0.700, 0.420, 0.300, 0.100, 0.560, 0.420, 0.5,
//              0.140, 0.100, 0.040, 0.030, 0.160, BEED_DefaultArregloTexturas )
// }
//        
// Ejemplo con la macro detallada, mismo objeto default
// #include "BEED.inc"     
// #local UnArreglo             = array[ BEED_TotalTexturas ] 
// #local UnArreglo[ BEED_IndiceTexturaPrincipal  ]  = PinkAlabaster
// #local UnArreglo[ BEED_IndiceTexturaDinamica   ]  = PinkAlabaster
// #local UnArreglo[ BEED_IndiceTexturaSoporte    ]  = PinkAlabaster
// #local UnArreglo[ BEED_IndiceTexturaDecorativa ]  = PinkAlabaster
// #local UnArreglo[ BEED_IndiceTexturaPedal      ]  = PinkAlabaster
// object                       {
//   BEED_BicicletaEstacionariaEstiloDejavu( 0, 0, 0,
//              0.700, 0.420, 0.300, 0.100, 0.560, 0.420, 0.5,
//              0.140, 0.100, 0.040, 0.030, 0.160, UnArreglo )
// }
//
// Con modificadores
// #include "BEED.inc"
// #include "textures.inc"
// #declare BEED_TexturaPrincipal   = PinkAlabaster
// object        { BEED_BicicletaEstacionaria(0,0,0) }
//
#include "metals.inc"   
#include "stones.inc"
#include "BEED_AU1.inc"
#declare BEED_L                 = 0.001;

#if ( version < 3.2 )
  #ifndef( BEED_POV3_1 )
    #declare BEED_POV3_1        = on;
  #end
#else
  #ifndef( BEED_POV3_1 )
    #declare BEED_POV3_1        = off;
  #end
#end

#declare BEED_TotalTexturas                     = 5;
#declare BEED_IndiceTexturaPrincipal            = 0;
#declare BEED_IndiceTexturaDinamica             = 1;
#declare BEED_IndiceTexturaSoporte              = 2;
#declare BEED_IndiceTexturaDecorativa           = 3;
#declare BEED_IndiceTexturaPedal                = 4;

#declare BEED_DefaultTexturaPrincipal   =
    texture                     {                         
      T_Chrome_2C    
      normal                              { 
        ripples               
        turbulence        1
        scale             1
      } 
    }  


#ifndef ( BEED_TexturaPrincipal )
  #declare BEED_TexturaPrincipal        = BEED_DefaultTexturaPrincipal
#end  // #ifndef ( BEED_TexturaPrincipal )

#declare BEED_DefaultTexturaDinamica   =
    texture                     {                         
      pigment { color ( 2*Blue+Cyan )/3 }
      normal                              { 
        ripples               
        turbulence        1.0
        scale             0.025
      } 
    }  


#ifndef ( BEED_TexturaDinamica )
  #declare BEED_TexturaDinamica        = BEED_DefaultTexturaDinamica
#end  // #ifndef ( BEED_TexturaDinamica )

#declare BEED_DefaultTexturaSoporte   =
    texture                     {                         
      T_Stone31
      scale 0.01
    }  


#ifndef ( BEED_TexturaSoporte )
  #declare BEED_TexturaSoporte        = BEED_DefaultTexturaSoporte
#end  // #ifndef ( BEED_TexturaSoporte )

#declare BEED_DefaultTexturaDecorativa   =
    texture                     {                         
      pigment                   { 
        onion
        turbulence              0.3
        scale                   0.01
        color_map               {  
            [ 0.0 Gray25 ]
            [ 1.0 Gray15 ]
        }                
        triangle_wave
      }
      normal                              { 
        ripples               
        turbulence        0.2
        scale             0.025
      } 
    }  


#ifndef ( BEED_TexturaDecorativa )
  #declare BEED_TexturaDecorativa        = BEED_DefaultTexturaDecorativa
#end  // #ifndef ( BEED_TexturaDecorativa )

#declare BEED_DefaultTexturaPedal       =
    texture                     {                         
      pigment                   {
        gradient            z
        turbulence          0.3 
        scale               0.01
        color_map               {
          [ 0.0 Gray20 ]
          [ 1.0 Gray10 ]
        }       
        triangle_wave
      }
      normal                              { 
        gradient          z
        turbulence        0.2
        scale             0.01
      } 
    }  


#ifndef ( BEED_TexturaPedal )
  #declare BEED_TexturaPedal            = BEED_DefaultTexturaPedal
#end  // #ifndef ( BEED_TexturaSujetador )   

#declare BEED_DefaultArregloTexturas              = array [5]
      { BEED_DefaultTexturaPrincipal, BEED_DefaultTexturaDinamica,
        BEED_DefaultTexturaSoporte, BEED_DefaultTexturaDecorativa,
        BEED_DefaultTexturaPedal }


#macro BEED_SweepTriplePuntoSuave( P, C, Q, Radio, Curvatura, BanderaEsfera )
  union                                 {
    #local CPUnitario                   = vnormalize( P-C );
    #local CQUnitario                   = vnormalize( Q-C );
    #local AnguloInterno                =
                        acos( vdot( CPUnitario, CQUnitario ) );
    #local Sita                         = AnguloInterno-pi/2;
    #local SobreCilindro                =
                Curvatura*( 1/cos( Sita )-tan( Sita ) );
    #local FinalP                       =
                C+SobreCilindro*CPUnitario;
    #local FinalQ                       =
                C+SobreCilindro*CQUnitario;
    cylinder                            {
      P, FinalP, Radio
    }
    cylinder                            {
      Q, FinalQ, Radio
    }
    #local PuntoGuia                    = ( FinalP+FinalQ )/2;    
    #local Alfa                         = ( pi/2-Sita )/2;
    #local Diagonal                     = Curvatura/cos( Alfa );
    #local CCorregido                   =
        C+( Diagonal-Curvatura )*vnormalize( PuntoGuia-C );
    BEED_SweepTriplePunto( FinalP, CCorregido, FinalQ, Radio, true )
    #if ( BanderaEsfera )
      sphere    { P, Radio }
      sphere    { Q, Radio }
    #end  // #if ( BanderaEsfera )
  }
#end  // #macro BEED_SweepTriplePuntoSuave

#macro BEED_BicicletaEstacionariaEstiloDejavu(
      AnguloCiclo, PedalDerecho, PedalIzquierdo,
      AltoFundamental, ProfundidadFundamental,
      SeparacionManivela, LargoPedal,
      AltoManivela, AltoAsiento,
      FraccionDelantera, AltoBase,
      DiametroSoporte, DiametroPrincipal,
      DiametroAgarradera, DiametroPedal, ArregloTexturas )
  union                                 {
    #local TexturaPrincipal             =
                ArregloTexturas[ BEED_IndiceTexturaPrincipal ]
    #local TexturaDinamica              =
                ArregloTexturas[ BEED_IndiceTexturaDinamica ]
    #local TexturaSoporte               =
                ArregloTexturas[ BEED_IndiceTexturaSoporte ]
    #local TexturaDecorativa            =
                ArregloTexturas[ BEED_IndiceTexturaDecorativa ]
    #local TexturaPedal                 =
                ArregloTexturas[ BEED_IndiceTexturaPedal ]
    #local AirePedal                    = 0.5*DiametroSoporte/2;
    #local PuntoBasal                   =
                        ( AltoBase+DiametroPrincipal/2 )*y;
    #local PuntoSoporteManivela         =
                < FraccionDelantera*ProfundidadFundamental,
                        AltoManivela, 0 >;
    #local PuntoSoporteAsiento          =
                < ( 1-FraccionDelantera )*ProfundidadFundamental,
                        AltoAsiento-DiametroPrincipal/2, 0 >;
    // Estructura Soporte Dinamico
    union                               {
      #local Cruce1                     =
        < PuntoSoporteManivela.x,
          PuntoSoporteManivela.x*tan( pi/4 )+PuntoBasal.y, 0 >;
      #local Cruce2                     =
        < PuntoSoporteAsiento.x,
          abs( PuntoSoporteAsiento.x )*tan( pi/6 )+PuntoBasal.y, 0 >;
      object                            {
        BEED_SweepTriplePuntoSuave
                ( PuntoBasal, Cruce1, PuntoSoporteManivela,
                  DiametroPrincipal/2, PuntoSoporteManivela.x, true )
      }
      object                            {
        BEED_SweepTriplePuntoSuave
                ( PuntoBasal, Cruce2, PuntoSoporteAsiento,
                  DiametroPrincipal/2, 2*PuntoSoporteAsiento.x/3, false )
        rotate                          180*y
      }
    }
    // Extremo Asiento
    union                               {
      #local Pendiente                  = 0.05;
      prism                             {
        conic_sweep
        cubic_spline
        -1, -1+Pendiente,  10,
        < 0.3,-0.2 >,
        < 0.5, 0 >,
        < 0.3, 0.2 >,
        < 0.0, 0.25 >,
        <-0.5, 0.5 >,
        <-0.5,-0.5 >,
        < 0.0,-0.25 >,
        < 0.3,-0.2 >,
        < 0.5, 0 >,
        < 0.3, 0.2 >
        translate       ( 1-Pendiente )*y
        scale           <1,1/Pendiente,1>
        scale           < -4*DiametroPrincipal,
                            DiametroPrincipal/2, 4*DiametroPrincipal >

      }
      translate                 PuntoSoporteAsiento*<-1,1,1>
    }
    // Pedales
    #local GruesoCilindroPedal          = 0.025*DiametroPedal;
    #local DimensionPedal               =
                        LargoPedal*< 0.75, 0.35, 1 >;
    union                               {
      #local C                          = 0;
      #while ( C < 2 )
        union                           {
          cylinder                      {
            0, GruesoCilindroPedal*z, DiametroPedal/2
            translate           ( DiametroSoporte/2+AirePedal )*z
            texture             { TexturaDinamica }
          }
          union                         {
            cylinder                    {
              0, 1*z
              0.4
              scale             <0.30,1,1>
            }
            difference                  {
              superellipsoid            {
                <0.3,0.9>
                rotate          90*y
                rotate          90*z
                scale           <0.475,0.5,0.5>
              }
              box                       {
                <-0.35,-1,-0.15>
                <+0.35,+1,+0.15>
              }
              box                       {
                <-0.30,-1,+0.400>
                <+0.30,+1,+0.250>
              }
              box                       {
                <-0.30,-1,-0.400>
                <+0.30,+1,-0.250>
              }
              translate                 0.515*z
            }
            texture                     {
              TexturaPedal
            }
            scale               DimensionPedal
            translate           ( DiametroSoporte/2+AirePedal
                                        +GruesoCilindroPedal )*z
            #if ( C = 1 )
              rotate                      -AnguloCiclo*z
              rotate                    PedalDerecho*z
              translate             -( DiametroPedal/2-DimensionPedal.y/2 )*y
            #else  // #else ( C = 1 )
              rotate                      -AnguloCiclo*z
              rotate                    PedalIzquierdo*z
              translate             +( DiametroPedal/2-DimensionPedal.y/2 )*y
            #end   // #else ( C = 1 )
          }
          #if ( C = 1 )
            scale                       < 1, 1, -1 >
          #end  // #if ( C = 1 )
        }
        #local C                        = C+1;
      #end  // #while ( C < 2 )
      rotate                            AnguloCiclo*z
      translate                         PuntoBasal+DiametroPrincipal*y
    }
    // Estructura Manivela
    union                               {
      #local PuntoAlto                  =
                < 0.45*FraccionDelantera*ProfundidadFundamental,
                  AltoFundamental, SeparacionManivela/2 >;
      #local PuntoBajo                  =
                < 0.45*FraccionDelantera*ProfundidadFundamental,
                  AltoManivela, SeparacionManivela/2 >;
      #local CentroManivela             =
                < PuntoAlto.x-( AltoFundamental-AltoManivela )*tan( pi/3 ),
                  AltoManivela, SeparacionManivela/2 >;
      #local CentroSoporte              =
                < PuntoSoporteManivela.x,
                  CentroManivela.y, CentroManivela.z >;
      #local PuntoCuero                 =
                ( 7*PuntoAlto+3*CentroManivela )/10;
      union                             {
        cylinder                          {
          PuntoAlto, PuntoCuero, DiametroPrincipal/2
        }
        union                           {
          torus                         {
            DiametroPrincipal/2, DiametroAgarradera/4
            rotate                      120*z
          }
          sphere                        {
            0, 1
            scale               < DiametroPrincipal/2,
                                  DiametroAgarradera/4,
                                  DiametroPrincipal/2 >
            rotate                      120*z
          }
          translate                     PuntoAlto
        }
        texture         { 
          TexturaDecorativa   
          translate                 PuntoAlto
        }
      }
      union                             {
        cylinder                          {
          PuntoAlto, PuntoCuero, DiametroPrincipal/2
        }
        union                           {
          torus                         {
            DiametroPrincipal/2, DiametroAgarradera/4
            rotate                      120*z
          }
          sphere                        {
            0, 1
            scale               < DiametroPrincipal/2,
                                  DiametroAgarradera/4,
                                  DiametroPrincipal/2 >
            rotate                      120*z
          }
          translate                     PuntoAlto
        }
        texture                         { 
          TexturaDecorativa              
          translate                     PuntoAlto
        }
        translate               -SeparacionManivela*z
      }
      object                            {
        BEED_SweepTriplePuntoSuave
                ( PuntoAlto, CentroManivela, PuntoBajo,
                  DiametroAgarradera/2, PuntoSoporteManivela.x/4, false )
      }
      object                            {
        BEED_SweepTriplePuntoSuave
                ( PuntoSoporteManivela, CentroSoporte, PuntoBajo,
                  DiametroAgarradera/2, PuntoSoporteManivela.x/6, true )
      }
      object                            {
        BEED_SweepTriplePuntoSuave
                ( PuntoAlto, CentroManivela, PuntoBajo,
                  DiametroAgarradera/2, PuntoSoporteManivela.x/4, false )
        translate               -SeparacionManivela*z
      }
      object                            {
        BEED_SweepTriplePuntoSuave
                ( PuntoSoporteManivela, CentroSoporte, PuntoBajo,
                  DiametroAgarradera/2, PuntoSoporteManivela.x/6, true )
        scale                   <1,1,-1>
      }
      superellipsoid                    {
        <0.2,0.2>
        scale           DiametroPrincipal*<0.5,0.75,0.5>
        translate               PuntoSoporteManivela
      }
    }
    // Estructura Base
    union                               {
      cylinder                          {
        0, PuntoBasal, DiametroSoporte/2
      }
      cylinder                          {
        -( DiametroSoporte/2+AirePedal/2 )*z, ( DiametroSoporte/2+AirePedal/2 )*z,
        DiametroPrincipal/2
        translate               PuntoBasal+DiametroPrincipal*y
      }
      cylinder                          {
        -( DiametroSoporte/2+AirePedal )*z, ( DiametroSoporte/2+AirePedal )*z,
        0.8*DiametroPrincipal/2
        translate               PuntoBasal+DiametroPrincipal*y
        texture                         {
          TexturaDinamica
        }
      }
      sphere                            {
        PuntoBasal, DiametroSoporte/2
      }
      difference                        {
        torus                           {
          DiametroSoporte/2, DiametroSoporte/2
        }
        plane                           {
          y, 0
        }
        texture                         {
          TexturaSoporte
        }
      }
    }
    texture                             {
      TexturaPrincipal
    }
  }
#end   // #macro BEED_BicicletaEstacionariaDejavu

#macro BEED_BicicletaEstacionaria( AnguloCiclo, PedalDerecho, PedalIzquierdo )
  object                                {
    #local L                            = BEED_L;
    #local AltoFundamental              = 700*L;
    #local ProfundidadFundamental       = 420*L;
    #local SeparacionManivela           = 300*L;
    #local LargoPedal                   = 100*L;
    #local AltoManivela                 = 560*L;
    #local AltoAsiento                  = 420*L;
    #local FraccionDelantera            = 0.5;
    #local AltoBase                     = 140*L;
    #local DiametroSoporte              = 100*L;
    #local DiametroPrincipal            =  40*L;
    #local DiametroAgarradera           =  30*L;
    #local DiametroPedal                = 160*L;
    #local ArregloTexturas              = array [5]
      { BEED_TexturaPrincipal, BEED_TexturaDinamica,
        BEED_TexturaSoporte, BEED_TexturaDecorativa,
        BEED_TexturaPedal }
    BEED_BicicletaEstacionariaEstiloDejavu(
      AnguloCiclo, PedalDerecho, PedalIzquierdo,
      AltoFundamental, ProfundidadFundamental,
      SeparacionManivela, LargoPedal,
      AltoManivela, AltoAsiento,
      FraccionDelantera, AltoBase,
      DiametroSoporte, DiametroPrincipal,
      DiametroAgarradera, DiametroPedal, ArregloTexturas )
  }
#end  // #macro BEED_BicicletaEstacionaria
