// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 19 abril 2016
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// BEED BicicletaEstacionariaEstiloDejavu
// El archivo dibuja una bicileta estacionaria, similar a las que
// se encuentran actualmente en algunos parques publicos de Costa Rica.
//
// La macro principal tiene tres parametros. 
// #macro BEED_BicicletaEstacionaria( AnguloCiclo, PedalDerecho, PedalIzquierdo )
//      AnguloCiclo             : Angulo para girar el ciclo de rotacion de pedales.
//      PedalDerecho            : Angulo respecto de la horizontal, para el pedal derecho
//          del usuario.
//      PedalIzquierdo          : Angulo respecto de la horizontal, para el pedal izquierdo
//          del usuario.
//
// La siguiente macro permite modificar algunas caracteristicas con mas detalle.
// #macro BEED_BicicletaEstacionariaEstiloDejavu(
//                AnguloCiclo, PedalDerecho, PedalIzquierdo,
//                AltoFundamental, ProfundidadFundamental,
//                SeparacionManivela, LargoPedal,
//                AltoManivela, AltoAsiento,
//                FraccionDelantera, AltoBase,
//                DiametroSoporte, DiametroPrincipal,
//                DiametroAgarradera, DiametroPedal, ArregloTexturas )
//      AnguloCiclo             : Angulo para girar el ciclo de rotacion de pedales.
//      PedalDerecho            : Angulo respecto la horizontal, para el pedal derecho
//          del usuario.
//      PedalIzquierdo          : Angulo respecto la horizontal, para el pedal izquierdo
//          del usuario.  
//      AltoFundamental         : Alto Y principal de referencia para el aparato.
//              Valor por defecto 700*L. 
//      ProfundidadFundamental  : Separacion X entre los ejes de los tubos 
//              frontal y posterior. Valor por defecto 420*L.
//      SeparacionManivela      : Separacion Z entre las dos agarraderas.
//              Valor por defecto 300*L.
//      LargoPedal              : Tamano referencia para dibujar el pedal.
//              Valor por defecto 100*L.
//      AltoManivela            : Altura del punto de apoyo de la manivela.
//              Valor por defecto 560*L.
//      AltoAsiento             : Altura del asiento. Valor por defecto 420*L.
//      FraccionDelantera       : Fraccion de ProfundidadFundamental que se asigna
//              al tubo soporte delantero. Valor por defecto 0.5.
//      AltoBase                : Altura del soporte inferior del aparato.
//              Valor por defecto 140*L.
//      DiametroSoporte         : Diametro del tubo principal de soporte.
//              Valor por defecto 100*L.
//      DiametroPrincipal       : Diametro de los tubos frontal y posterior.
//              Valor por defecto 40*L.
//      DiametroAgaradera       : Diametro del manubrio. Valor por defecto 30*L.
//      DiametroPedal           : Diametro del cilindro de giro soporte de pedales.
//              Valor por defecto 160*L.
//      ArregloTexturas         : Arreglo de cinco texturas
//              { BEED_IndiceTexturaPrincipal, BEED_IndiceTexturaDinamica,
//                BEED_IndiceTexturaSoporte, BEED_IndiceTexturaDecorativa,
//                BEED_IndiceTexturaPedal }. Valor por defecto { BEED_TexturaPrincipal,
//                BEED_TexturaDinamica, BEED_TexturaSoporte, BEED_TexturaDecorativa,
//                BEED_TexturaPedal }. 
//                  BEED_IndiceTexturaPrincipal     : textura principal.
//                  BEED_IndiceTexturaDinamica      : cilindro de giro.
//                  BEED_IndiceTexturaSoporte       : soporte en la base.
//                  BEED_IndiceTexturaDecorativa    : cuero de manivela.
//                  BEED_IndiceTexturaPedal         : pedales.
//              El total de texturas es BEED_TotalTexturas.      
//      
// La bicicleta estacionaria se encuentra completamente contenida
// en las siguientes coordenadas.
//      Minimo  = < -300,    0, -180 >*L
//      Maximo  = <  226,  725,  180 >*L  
// Frente mira hacia X+, gravedad Y-. El cilindro de giro alineado con el origen del
// plano XZ.
//
// Estas son variables predefinidas o generadas en el
// interna de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare BEED_DefaultTexturaPrincipal        
//      Textura principal a aplicar en la estructura.
// #declare BEED_DefaultTexturaDinamica         
//      Textura del eje de giro de los pedales.
// #declare BEED_DefaultTexturaSoporte          
//      Textura de la base inferior.
// #declare BEED_DefaultTexturaDecorativa       
//      Textura para decoracion del cuero de la manivela.
// #declare BEED_DefaultTexturaPedal        
//      Textura de los pedales de la bicicleta.
// #declare BEED_DefaultArregloTexturas
//      Contiene un arreglo con las texturas por defecto sin modificar. 
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare BEED_TexturaPrincipal                   = texture { ... }        
//      Textura principal a aplicar en la estructura.
// #declare BEED_TexturaDinamica                    = texture { ... }         
//      Textura del eje de giro de los pedales.
// #declare BEED_TexturaSoporte                     = texture { ... }
//      Textura de la base inferior.
// #declare BEED_TexturaDecorativa                  = texture { ... }
//      Textura para decoracion del cuero de la manivela.
// #declare BEED_TexturaPedal                       = texture { ... }
//      Textura de los pedales de la bicicleta.
//        
// Para colocarlo simplemente
// #include "BEED.inc" 
// object { BEED_BicicletaEstacionaria(0,0,0)
//                                  
// Ejemplo con la macro detallada, mismo objeto default
// #include "BEED.inc"   
// object                       {
//   BEED_BicicletaEstacionariaEstiloDejavu( 0, 0, 0,
//              0.700, 0.420, 0.300, 0.100, 0.560, 0.420, 0.5,
//              0.140, 0.100, 0.040, 0.030, 0.160, BEED_DefaultArregloTexturas )
// }
//        
// Ejemplo con la macro detallada, mismo objeto default
// #include "BEED.inc"     
// #local UnArreglo             = array[ BEED_TotalTexturas ] 
// #local UnArreglo[ BEED_IndiceTexturaPrincipal  ]  = PinkAlabaster
// #local UnArreglo[ BEED_IndiceTexturaDinamica   ]  = PinkAlabaster
// #local UnArreglo[ BEED_IndiceTexturaSoporte    ]  = PinkAlabaster
// #local UnArreglo[ BEED_IndiceTexturaDecorativa ]  = PinkAlabaster
// #local UnArreglo[ BEED_IndiceTexturaPedal      ]  = PinkAlabaster
// object                       {
//   BEED_BicicletaEstacionariaEstiloDejavu( 0, 0, 0,
//              0.700, 0.420, 0.300, 0.100, 0.560, 0.420, 0.5,
//              0.140, 0.100, 0.040, 0.030, 0.160, UnArreglo )
// }
//
// Con modificadores
// #include "BEED.inc"
// #include "textures.inc"
// #declare BEED_TexturaPrincipal   = PinkAlabaster
// object        { BEED_BicicletaEstacionaria(0,0,0) }
//
#if ( version >= 3.7 )
  #version 3.7; 
#end

global_settings { assumed_gamma 1.0 }
#include "colors.inc"
         
#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}   
 
#include "BEED.inc"

#local FactorAcercamiento       = 1.75;   
                                   
object                                  {
  BEED_BicicletaEstacionaria( 70, 40, -5 )     
  translate             -0.375*y       
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z   
}

