// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 24 mayo 2016
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// EDEP EmpujeDobleExhibicionPublica
// El archivo dibuja un aparato de ejercicios de tipo empuje doble, similar a los que
// se encuentran actualmente en algunos parques publicos de Costa Rica.
//
// La macro principal tiene dos parametros. 
// #macro EDEP_EmpujeDoble( FraccionDerecho, FraccionIzquierdo )  
//      FraccionDerecho         : Fraccion propia de empuje para las barras
//              en el hemisferio X-.
//      FraccionIzquierdo       : Fraccion propia de empuje para las barras
//              en el hemisferio X+.
//
// La siguiente macro permite modificar algunas caracteristicas.
// #macro EDEP_EmpujeDobleExhibicionPublica(
//               FraccionDerecho, FraccionIzquierdo,
//               AltoFundamental, AltoEjeSuperior, AltoEjeInferior,
//               LargoEjeSuperior, LargoSilla, DiametroSoporte,
//               DiametroSecundario, SeparacionEjeSilla,
//               SeparacionBrazos, LargoSuperiorBrazo,
//               TexturaPrincipal, TexturaSoporte,
//               TexturaDinamica, TexturaSujetador,
//               TexturaDecorativa, TexturaMango )
//      FraccionDerecho         : Fraccion propia de empuje para las barras
//              en el hemisferio X-.
//      FraccionIzquierdo       : Fraccion propia de empuje para las barras
//              en el hemisferio X+.  
//      AltoFundamental         : Alto del aparato. Valor por defecto 1425*L.
//      AltoEjeSuperior         : Altura desde el suelo para la barra divisoria
//              superior. Valor por defecto 1200*L.
//      AltoEjeInferior         : Altura desde el suelo para la barra divisoria
//              inferior. Valor por defecto 370*L.
//      LargoEjeSuperior        : Referencia para el largo de la barra divisoria
//              superior. Valor por defecto 380*L.
//      LargoSilla              : Referencia para el largo X de la silla.
//              Valor por defecto 225*L.
//      DiametroSoporte         : Diametro de las barras principales que soportan la maquina.
//              Valor por defecto 100*L.
//      DiametroSecundario      : Diametro para tubos accesorios a las barras soporte.
//              Valor por defecto 42*L.
//      SeparacionEjeSilla      : Medida de la separacion entre las sillas y el eje central.
//              Valor por defecto 300*L.
//      SeparacionBrazos        : Separacion Z de los brazos de la maquina.
//              Valor por defecto 560*L.
//      LargoSuperiorBrazo      : Referencia para el largo de los brazos.
//              Valor por defecto 325*L.
//      TexturaPrincipal        : Textura principal a aplicar en la estructura.
//              Valor por defecto EDEP_TexturaPrincipal.
//      TexturaSoporte          : Textura de la base inferior.
//              Valor por defecto EDEP_TexturaSoporte.
//      TexturaDinamica         : Textura del empuje doble propiamente.
//              Valor por defecto EDEP_TexturaDinamica.
//      TexturaSujetador        : Textura de los aros metalicos para sujetar
//              el empuje doble a la estructura.  Valor por defecto EDEP_TexturaSujetador.
//      TexturaDecorativa       : Textura para decoracion de los extremos del soporte.
//              Valor por defecto EDEP_TexturaDecorativa.  
//      TexturaMango            : Textura para el mango del empuje doble.
//              Valor por defecto EDEP_TexturaMango.
//      
// La mquina de empuje doble con parametros nulos se encuentra completamente contenida
// entre las siguientes coordenadas.
//      Minimo  = < -725,    0, -300 >*L
//      Maximo  = <  725, 1440,  300 >*L  
// Los asientos miran hacia ambos sentidos del eje X, gravedad Y-. 
// El cilindro central alineado con el origen del plano XZ.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare EDEP_DefaultTexturaPrincipal        
//      Textura principal a aplicar en la estructura.
// #declare EDEP_DefaultTexturaSoporte          
//      Textura de la base inferior.
// #declare EDEP_DefaultTexturaDinamica         
//      Textura del empuje doble propiamente.
// #declare EDEP_DefaultTexturaSujetador        
//      Textura de los aros metalicos para sujetar
//      el empuje doble a la estructura.  
// #declare EDEP_DefaultTexturaDecorativa       
//      Textura para decoracion de los extremos del soporte.  
// #declare EDEP_DefaultTexturaMango
//      Textura para el mango del empuje doble.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare EDEP_TexturaPrincipal                   = texture { ... }        
//      Textura principal a aplicar en la estructura.
// #declare EDEP_TexturaSoporte                     = texture { ... }
//      Textura de la base inferior.
// #declare EDEP_TexturaDinamica                    = texture { ... }         
//      Textura del empuje doble propiamente.
// #declare EDEP_TexturaSujetador                   = texture { ... }
//      Textura de los aros metalicos para sujetar 
//      el empuje doble a la estructura.  
// #declare EDEP_TexturaDecorativa                  = texture { ... }
//      Textura para decoracion de los extremos del soporte.     
// #declare EDEP_TexturaMango                       = texture { ... }
//      Textura para el mango del empuje doble.
//        
// Para colocarlo simplemente
// #include "EDEP.inc" 
// object { EDEP_EmpujeDoble(0,0)
//                                  
// Ejemplo con la macro detallada, mismo objeto default
// #include "EDEP.inc"   
// object                       {
//   EDEP_EmpujeDobleExhibicionPublica( 0, 0,
//              1.425, 1.200, 0.370, 0.380, 0.225, 0.100, 0.042, 0.300, 0.560, 0.325, 
//              EDEP_TexturaPrincipal, EDEP_TexturaSoporte, EDEP_TexturaDinamica, 
//              EDEP_TexturaSujetador, EDEP_TexturaDecorativa, EDEP_TexturaMango )
// }
//        
// Con modificadores
// #include "EDEP.inc"
// #include "textures.inc"
// #declare EDEP_TexturaPrincipal   = PinkAlabaster
// object        { EDEP_EmpujeDoble(0,0) }
//
#include "colors.inc"
#include "metals.inc"

#declare EDEP_L                         = 0.001;

#if ( version < 3.2 )
  #ifndef( EDEP_POV3_1 )
    #declare EDEP_POV3_1        = on;
  #end
#else
  #ifndef( EDEP_POV3_1 )
    #declare EDEP_POV3_1        = off;
  #end
#end

#declare EDEP_DefaultTexturaPrincipal   =
    texture                     {                         
      T_Chrome_2C    
      normal                              { 
        ripples               
        turbulence        0.2
        scale             0.025
      } 
    }  


#ifndef ( EDEP_TexturaPrincipal )
  #declare EDEP_TexturaPrincipal        = EDEP_DefaultTexturaPrincipal
#end  // #ifndef ( EDEP_TexturaPrincipal )

#declare EDEP_DefaultTexturaDinamica   =
    texture                     {                         
      pigment { color ( 2*Blue+Cyan )/3 }
      normal                              { 
        ripples               
        turbulence        0.2
        scale             0.025
      } 
    }  


#ifndef ( EDEP_TexturaDinamica )
  #declare EDEP_TexturaDinamica        = EDEP_DefaultTexturaDinamica
#end  // #ifndef ( EDEP_TexturaDinamica )

#declare EDEP_DefaultTexturaSoporte   =
    texture                     {                         
      pigment { Gray30 }
      normal                              { 
        ripples               
        turbulence        0.2
        scale             0.025
      } 
    }  


#ifndef ( EDEP_TexturaSoporte )
  #declare EDEP_TexturaSoporte        = EDEP_DefaultTexturaSoporte
#end  // #ifndef ( EDEP_TexturaSoporte )

#declare EDEP_DefaultTexturaMango     =
    texture                     {                         
      pigment { Gray30 }
      normal                              { 
        ripples               
        turbulence        0.2
        scale             0.025
      } 
    }  


#ifndef ( EDEP_TexturaMango )
  #declare EDEP_TexturaMango          = EDEP_DefaultTexturaMango
#end  // #ifndef ( EDEP_TexturaSoporte )


#declare EDEP_DefaultTexturaDecorativa   =
    texture                     {                         
      pigment  { color ( 2*Blue+Cyan )/3 }
      normal                              { 
        ripples               
        turbulence        0.2
        scale             0.025
      } 
    }  


#ifndef ( EDEP_TexturaDecorativa )
  #declare EDEP_TexturaDecorativa        = EDEP_DefaultTexturaDecorativa
#end  // #ifndef ( EDEP_TexturaDecorativa )

#declare EDEP_DefaultTexturaSujetador   =
    texture                     {                         
      T_Chrome_4D
      normal                              { 
        ripples               
        turbulence        0.2
        scale             0.025
      } 
    }  


#ifndef ( EDEP_TexturaSujetador )
  #declare EDEP_TexturaSujetador        = EDEP_DefaultTexturaSujetador
#end  // #ifndef ( EDEP_TexturaSujetador )

#macro EDEP_EmpujeDobleExhibicionPublica(
                FraccionDerecho, FraccionIzquierdo,
                AltoFundamental, AltoEjeSuperior, AltoEjeInferior,
                LargoEjeSuperior, LargoSilla, DiametroSoporte,
                DiametroSecundario, SeparacionEjeSilla,
                SeparacionBrazos, LargoSuperiorBrazo,
                TexturaPrincipal, TexturaSoporte,
                TexturaDinamica, TexturaSujetador,
                TexturaDecorativa, TexturaMango )
  union                                 {
    #local AnguloMinimoEmpuje           = 1;
    #local AnguloMaximoEmpuje           = 35;
    #local EmpujeAnguloDerecho          =
                AnguloMinimoEmpuje+
                FraccionDerecho*( AnguloMaximoEmpuje-AnguloMinimoEmpuje );
    #local EmpujeAnguloIzquierdo        =
                AnguloMinimoEmpuje+
                FraccionIzquierdo*( AnguloMaximoEmpuje-AnguloMinimoEmpuje );
    #local AnguloSuperiorBrazo          =  60;
    #local AnguloInclinacionBrazo2      =  90;
    #local AnguloInclinacionHule        =  45;
    #local LargoHule                    =
                100*( AltoEjeSuperior-AltoEjeInferior )/830;
    #local LargoInteriorBrazo           =
                450*( AltoEjeSuperior-AltoEjeInferior )/830;
    #local AltoSilla                    =
                0.8*( AltoEjeSuperior-AltoEjeInferior )/3;
    #local AnchoSilla                   = SeparacionBrazos/3;
    #local LargoEjeInferior             = 381*LargoSilla/225;
    #local AltoInferior                 =
        ( AltoEjeInferior-DiametroSoporte-DiametroSecundario );
    // Eje principal de la estructura
    union                               {
      cylinder                          {
        0, ( AltoFundamental-DiametroSoporte/2 )*y, DiametroSoporte/2
      }
      difference                        {
        sphere                          {
          ( AltoFundamental-DiametroSoporte/2 )*y, 1.1*DiametroSoporte/2
        }
        plane                           {
          y, 0
        }
        texture                         {
          TexturaDecorativa
        }
      }
      difference                        {
        torus                           {
          DiametroSoporte/2, DiametroSoporte/2
        }
        plane                           {
          y, 0
        }
        texture                         {
          TexturaSoporte
        }
      }
    }
    // Eje Superior
    union                               {
      cylinder                          {
        -LargoEjeSuperior/2*x,
        +LargoEjeSuperior/2*x,
        DiametroSecundario/2
      }
      translate                         AltoEjeSuperior*y
    }
    // Silla Dinamico
    #local DiametroDinamico             = 0.8*DiametroSecundario;
    #local C                            = 0;
    #while ( C < 2 )
      union                             {
        #if ( C = 0 )
          #local AnguloAplicado         = EmpujeAnguloIzquierdo*pi/180;
        #else  // #else ( C = 0 )
          #local AnguloAplicado         = EmpujeAnguloDerecho*pi/180;
        #end   // #else ( C = 0 )
        #local HPiv                     = AltoEjeSuperior-AltoEjeInferior-DiametroSecundario
                                                -DiametroDinamico/2;
        #local EjeInferior              = 130/300*SeparacionEjeSilla;
        #local MPiv                     = 121/300*SeparacionEjeSilla;
        #local NPiv                     = SeparacionEjeSilla
                                                -EjeInferior-MPiv;
        #local APiv                     =
                 2*( SeparacionEjeSilla-LargoEjeSuperior/2 )/sqrt( 2 );
        #local XPiv                     = SeparacionEjeSilla
                                                -EjeInferior-sqrt( 2 )*APiv/2;
        #local LPiv                     = HPiv-sqrt( 2 )*APiv/2;
        #local SitaPiv                  = pi/4-AnguloAplicado;
        #local SitaPivD                 = SitaPiv*180/pi;
        #local Xapiv                    = XPiv+APiv*cos( SitaPiv );
        #local Yapiv                    = HPiv-APiv*sin( SitaPiv );
        #local Asincos                  = 2*MPiv*Yapiv;
        #local Bsincos                  = 2*MPiv*Xapiv;
        #local Csincos                  = Xapiv*Xapiv+Yapiv*Yapiv+MPiv*MPiv
                        -( LPiv*LPiv+NPiv*NPiv );
        #local ACuad                    = Asincos*Asincos+Bsincos*Bsincos;
        #local BCuad                    = -2*Asincos*Csincos;
        #local CCuad                    = Csincos*Csincos-Bsincos*Bsincos;
        #local Previoasin               =
                ( -BCuad-sqrt( BCuad*BCuad-4*ACuad*CCuad ) )/( 2*ACuad );
        #local FiPiv                    = asin( Previoasin );
        #local FiPivD                   = FiPiv*180/pi;
        // Eje atornillado Primero Inferior
        #local EjeAtornillado           =
          union                         {
            cylinder                      {
              -DiametroSecundario/2*z,
              +DiametroSecundario/2*z, DiametroSecundario/2
              texture                     {
                TexturaDinamica
              }
            }
            #local E                    = 0;
            #while ( E < 2 )
              union                     {
                difference              {
                  torus                 {
                    1.1*DiametroSecundario/4,
                    DiametroSecundario/4
                    rotate                90*x
                  }
                  plane                 {
                    z, 0
                  }
                }
                texture                 {
                  TexturaSujetador
                }
                translate               DiametroSecundario/2*z
                #if ( E = 1 )
                  scale                 <1,1,-1>
                #end  // #if ( E = 1 )
              }
              #local E                  = E+1;
            #end  // #while ( E < 2 )
          }
        // FIN declaracion EjeAtornillado
          
        union                           {
          object                        {
            EjeAtornillado
          }
          box                           {
            < 0   , -0.8*DiametroSecundario/2,-0.8*DiametroSecundario/2 >,
            < MPiv, +0.8*DiametroSecundario/2,+0.8*DiametroSecundario/2 >
            texture                     {
              TexturaDinamica
            }
            rotate              FiPivD*z
          }     
          cylinder                      {
            0, -0.75*AltoInferior*y, 0.6*DiametroSecundario/2
            texture                     {
              TexturaDinamica
            }
            translate                   MPiv/2*x+
                                        MPiv/2*tan( FiPiv )*y
          } 
          cylinder                      {
            0, -( AltoEjeSuperior-AltoEjeInferior-HPiv )*y, DiametroSecundario/2
          }
          object                        {
            EjeAtornillado
            translate   < MPiv*cos( FiPiv ), MPiv*sin( FiPiv ), 0 >
          }
          translate            ( AltoEjeSuperior-HPiv )*y+EjeInferior*x
        }
        // Eje Atornillado Superior
        union                           {
          object                        {
            EjeAtornillado
          }
          difference                    {
            box                           {
              < 0   , -0.8*DiametroSecundario/2,-0.8*DiametroSecundario/2 >,
              < APiv, +0.8*DiametroSecundario/2,+0.8*DiametroSecundario/2 >
            }
            box                           {
              < 0   , -DiametroSecundario/2,-0.6*DiametroSecundario/2 >,
              < MPiv, +DiametroSecundario/2,+0.6*DiametroSecundario/2 >
            }
            texture                     {
              TexturaDinamica
            }
            rotate                      -SitaPivD*z
          }
          object                        {
            EjeAtornillado
            translate   < APiv*cos( SitaPiv ), -APiv*sin( SitaPiv ), 0 >
          }
          translate            AltoEjeSuperior*y+( EjeInferior+XPiv )*x
        }
        // Brazo
        #local DiametroDecorativo       = 2*DiametroSoporte;
        union                           {
          cylinder                      {
            -( SeparacionBrazos/2-DiametroDecorativo/2 )*z,
            +( SeparacionBrazos/2-DiametroDecorativo/2 )*z,
            DiametroDinamico/2
          }
          #local D                      = 0;
          #while ( D < 2 )
            union                       {
              difference                {
                torus                   {
                  DiametroDecorativo/2, DiametroDinamico/2
                }
                plane                   {
                  -x, 0
                }
                plane                   {
                  z, 0
                }
                translate   +( SeparacionBrazos/2-DiametroDecorativo/2 )*z
                            +DiametroDecorativo/2*x
              }
              cylinder                  {
                DiametroDecorativo/2*x,
                ( LargoSuperiorBrazo-DiametroDecorativo/2 )*x,
                DiametroDinamico/2
                translate   +SeparacionBrazos/2*z
              }
              difference                {
                torus                   {
                  DiametroDecorativo/2, DiametroDinamico/2
                  rotate                90*x
                }
                plane                   {
                  x, 0
                }
                plane                   {
                  -x, 0
                  rotate                -AnguloInclinacionBrazo2*z
                }
                translate    < LargoSuperiorBrazo-DiametroDecorativo/2,
                               -DiametroDecorativo/2, SeparacionBrazos/2 >
              }
              union                     {
                cylinder                {
                  0, -LargoInteriorBrazo*x, DiametroDinamico/2
                }
                sphere                  {
                  0, DiametroDinamico/2
                  scale                 <0.2,1,1>
                }
                union                   {
                  cylinder              {
                    0, 0.15*LargoHule*x, 0.8*DiametroDinamico/2
                  }
                  union                 {
                    sphere              {
                      0, DiametroDinamico/2
                      scale             <0.2,1,1>
                    }
                    cylinder            {
                      0, LargoHule*x, 0.9*DiametroDinamico/2
                    }
                    sphere              {
                      0, DiametroDinamico/2
                      translate         LargoHule*x
                      scale             <0.2,1,1>
                    }
                    texture             {
                      TexturaMango
                      translate         LargoHule*x
                    }
                    translate           0.150*LargoHule*x
                  }
                  rotate                -AnguloInclinacionHule*z
                }
                texture                 {
                  TexturaDinamica
                }
                translate        +LargoInteriorBrazo*x+DiametroDecorativo/2*y
                rotate                  -AnguloInclinacionBrazo2*z
                translate    < LargoSuperiorBrazo-DiametroDecorativo/2,
                               -DiametroDecorativo/2, SeparacionBrazos/2 >
              }
              #if ( D = 1 )
                scale                   <1,1,-1>
              #end  // #if ( D = 1 )
            }
            #local D                    = D+1;
          #end  // #while ( D < 2 )
          rotate                ( AnguloSuperiorBrazo-SitaPivD )*z
          translate            AltoEjeSuperior*y+( EjeInferior+XPiv )*x
          translate   0.5*< APiv*cos( SitaPiv ), -APiv*sin( SitaPiv ), 0 >
          texture                       {
            TexturaDinamica
          }
        }
        // Eje de Silla
        #local Respaldo                 =
          difference                    {
            prism                       {
              linear_spline
              0, 1, 6,
              <0,-0.5>,
              <0.6,-0.5>,
              <1.0,-0.3>,
              <1.0,+0.3>,
              <0.6,+0.5>,
              <0,+0.5>
            }
            #local E                    = 0;
            #while ( E < 2 )
              union                       {
                cylinder                    {
                  -y, y, 0.05
                  translate         <0.2,0.5,0.3>
                }
                cylinder                    {
                  -y, y, 0.05
                  translate         <0.4,0.5,0.3>
                }
                cylinder                    {
                  -y, y, 0.05
                  translate         <0.6,0.5,0.2>
                }
                cylinder                    {
                  -y, y, 0.05
                  translate         <0.8,0.5,0.2>
                }
                #if ( E = 1 )
                  scale           <1,1,-1>
                #end  // #if ( E = 1 )
              }
              #local E                 = E+1;
            #end
          }
          // Fin Respaldo
          
        union                           {
          cylinder                      {
            0, +NPiv*x, DiametroDinamico/2
          }
          cylinder                      {
            0, LPiv*y, DiametroDinamico/2
            translate                   NPiv*x
          }
          sphere                        {
            NPiv*x, DiametroDinamico/2
          }
          difference                    {
            torus                       {
              DiametroDecorativo/2, DiametroDinamico/2
              rotate                    90*x
            }
            plane                       {
              -x, 0
            }
            plane                       {
              -y, 0
            }
            translate           NPiv*x+DiametroDecorativo/2*x
          }
          cylinder                      {
            0, LargoSilla*x, DiametroDinamico/2
            translate           NPiv*x+DiametroDecorativo/2*(x-y)
          }
          // Respaldo
          object                        {
            Respaldo
            scale       <LargoSilla,DiametroDinamico/2,AnchoSilla>
            translate           NPiv*x+DiametroDecorativo/2*(x-y)
          }
          object                        {
            Respaldo
            rotate                      180*y
            rotate                      -90*z
            scale       <DiametroDinamico/2,AltoSilla,AnchoSilla>
            translate           ( NPiv+DiametroDinamico/2 )*x
                                +DiametroDecorativo/4*y
          }
          texture                       {
            TexturaDinamica
          }
          rotate            -( degrees( atan2( LPiv ,  NPiv ) )
                              -degrees( atan2( Yapiv-MPiv*sin( FiPiv ) ,
                                               Xapiv-MPiv*cos( FiPiv ) ) ) )*z
          translate   < MPiv*cos( FiPiv ), MPiv*sin( FiPiv ), 0 >
          translate            ( AltoEjeSuperior-HPiv )*y+EjeInferior*x
        }
        #if ( C = 1 )
          scale                         <-1,1,1>
        #end  // #if ( C = 1 )
      }
      #local C                          = C+1;
    #end  // #while ( C < 2 )
    // Eje Inferior
    union                               {
      cylinder                          {
        -LargoEjeInferior/2*x,
        +LargoEjeInferior/2*x,
        DiametroSecundario/2
      }    
      cylinder                          {
        DiametroSecundario/2*y, -( AltoInferior+DiametroSecundario )*y, DiametroSecundario/2
        translate               +( EjeInferior+MPiv/2 )*x
      }
      cylinder                          {
        DiametroSecundario/2*y, -( AltoInferior+DiametroSecundario )*y, DiametroSecundario/2
        translate               -( EjeInferior+MPiv/2 )*x
      } 
      cylinder                          {
        -LargoEjeInferior/2*x,
        +LargoEjeInferior/2*x,
        DiametroSecundario/4
        translate                       -AltoInferior*y
      }
      translate                         AltoEjeInferior*y
    }
    texture                             {
      TexturaPrincipal
    }
  }
#end  // #macro EDEP_EmpujeDobleExhibicionPublica

#macro EDEP_EmpujeDoble( FraccionDerecho, FraccionIzquierdo )
  object                                {
    #local L                            = EDEP_L;
    #local AltoFundamental              = 1425*L;
    #local AltoEjeSuperior              = 1200*L;
    #local AltoEjeInferior              =  370*L;
    #local LargoEjeSuperior             =  380*L;
    #local LargoSilla                   =  225*L;
    #local DiametroSoporte              =  100*L;
    #local DiametroSecundario           =   42*L;
    #local SeparacionEjeSilla           =  300*L;
    #local SeparacionBrazos             =  560*L;
    #local LargoSuperiorBrazo           =  325*L;
    EDEP_EmpujeDobleExhibicionPublica(
                FraccionDerecho, FraccionIzquierdo,
                AltoFundamental, AltoEjeSuperior, AltoEjeInferior,
                LargoEjeSuperior, LargoSilla, DiametroSoporte,
                DiametroSecundario, SeparacionEjeSilla,
                SeparacionBrazos, LargoSuperiorBrazo,
                EDEP_TexturaPrincipal, EDEP_TexturaSoporte,
                EDEP_TexturaDinamica, EDEP_TexturaSujetador,
                EDEP_TexturaDecorativa, EDEP_TexturaMango )
  }
#end  // #macro EDEP_Caminadora
