// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 22 febrero 2017
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// MIHD MotocicletaImitacionHarleyDavidson
// El archivo dibuja una motocicleta Harley Davidson de juguete,
// segn modelo 2012 XL 1200V seventy-two.             
// Casi no permite modificaciones, aunque se pueden variar las texturas.
// Es compatible con POV-Ray 3.1.
//
// La macro tiene cuatro parametros.  
// #macro MIHD_Motocicleta( GiroFrontal, RodarFrontal, 
//                            RodarPosterior, BalancePosterior ) 
//      GiroFrontal             : Angulo de giro de la manivela frontal.
//      RodarFrontal            : Angulo de rotacion de la llanta delantera.
//      RodarPosterior          : Angulo de rotacion de la llanta posterior.
//      BalancePosterior        : Use angulos muy pequenos.
//              Permite levantar la llanta
//              posterior debido al peso y movimiento del aparato.
//              En este movimiento considere que el asiento permanece
//              estatico, y la llanta dejara de tocar el suelo.
//
// La motocicleta con parametros nulos se encuentra contenida completamente 
// entre las siguientes coordenadas:
//      Minimo          = < -54.4,   0.0, -20.4 >*L
//      Maximo          = < +30.3, +46.2, +20.4 >*L
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare MIHD_DefaultTexturaReencauche        
//      Textura de las llantas.
// #declare MIHD_DefaultTexturaMetalica          
//      Textura principal de las partes metalicas.
// #declare MIHD_DefaultTexturaPresion         
//      Textura para presion delantera.
// #declare MIHD_DefaultTexturaPrincipal        
//      Textura principal de la motocicleta. 
// #declare MIHD_DefaultTexturaCuero
//      Textura de elementos de cuero.
// #declare MIHD_DefaultTexturaTubular
//      Textura de tubos de conduccion externos.
// #declare MIHD_DefaultTexturaFondoFocoPrincipal
//      Fondo del foco principal delantero.
// #declare MIHD_DefaultTexturaVidrioFocoPrincipal
//      Textura del vidrio del foco principal delantero.
// #declare MIHD_DefaultTexturaFondoFocoLateral
//      Fondo del foco lateral posterior.
// #declare MIHD_DefaultTexturaVidrioFocoLateral
//      Textura del vidrio de focos laterales traseros.
// #declare MIHD_DefaultTexturaDecorativaLateral
//      Textura decoracion laterales posteriores.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare MIHD_TexturaReencauche                = texture { ... }
//      Textura de las llantas.
// #declare MIHD_TexturaMetalica                  = texture { ... }         
//      Textura principal de las partes metalicas.
// #declare MIHD_TexturaPresion                   = texture { ... }     
//      Textura para presion delantera.
// #declare MIHD_TexturaPrincipal                 = texture { ... }    
//      Textura principal de la motocicleta. 
// #declare MIHD_TexturaCuero                     = texture { ... }
//      Textura de elementos de cuero.
// #declare MIHD_TexturaTubular                   = texture { ... }
//      Textura de tubos de conduccion externos.
// #declare MIHD_TexturaFondoFocoPrincipal        = texture { ... }
//      Fondo del foco principal delantero.
// #declare MIHD_TexturaVidrioFocoPrincipal       = texture { ... }
//      Textura del vidrio del foco principal delantero.
// #declare MIHD_TexturaFondoFocoLateral          = texture { ... }
//      Fondo del foco lateral posterior.
// #declare MIHD_TexturaVidrioFocoLateral         = texture { ... }
//      Textura del vidrio de focos laterales traseros.
// #declare MIHD_TexturaDecorativaLateral         = texture { ... }
//      Textura decoracion laterales posteriores.
//        
// Para colocarlo simplemente
// #include "MIHD.inc" 
// object { MIHD_Motocicleta( 0, 0, 0, 0 ) }
//                                 
// Ejemplo con la macro detallada, mismo objeto default
// Con modificadores
// #include "MIHD.inc"
// #include "textures.inc"
// #declare MIHD_TexturaPrincipal     = { PinkAlabaster }
// object { MIHD_Motocicleta( 0, 0, 0, 0 ) }
//                                 
#if ( version >= 3.7 )
  #version 3.7; 
#end

global_settings { assumed_gamma 1.0 }

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "MIHD.inc"

#declare FactorAcercamiento             = 20;

object                    {
  MIHD_Motocicleta( 0, 0, 0, 0 )  
  translate       -0.023*y+0.012*x  
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z      
}
                     