// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 24 enero 2017
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//      
// MPBA MariposaPlasticoBrillanteArtificial
// Un rompecabezas tridimensional en forma de mariposa (el original brilla en
// la oscuridad). Es muy poco flexible, pero se puede modificar los materiales,
// y las piezas pueden dibujarse en forma individual. 
// Es compatible con POV-Ray 3.1. 
//
// Un alto porcentaje del modelo fue disenado mediante 
// la herramienta Epspline.exe, para prismas. 
// El interesado puede conseguir el programa Epspline.exe en 
// http://agalena.nfshost.com/b1/ 
//
// La macro principal no tiene parametros.   
// #macro Mariposa()
//
// La mariposa se encuentra completamente contenida en:   
//      Punto Minimo    = < - 80,    0, - 48 >*L
//      Punto Maximo    = < +103, +130, + 48 >*L 
// La mariposa mira hacia X- gravedad Y-. Descansa directamente sobre
// el plano XZ. Es completamente simetrica respecto al plano XY.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente. 
// Excepto por MPBA_Pieza4, las piezas se ubican en su lugar correcto.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare MPBA_DefaultMaterialPrincipal       
//      Material principal a aplicar al objeto.
// #declare MPBA_DefaultMaterialAlas          
//      Material para las alas.
// #declare MPBA_DefaultMaterialPatas           
//      Material para aplicar a las patas.
// #declare MPBA_Pieza1   
//      Corresponde a las alas grandes.
// #declare MPBA_Pieza2
//      Corresponde a las alas pequenas.
// #declare MPBA_Pieza3   
//      Corresponde a las antenas y cabeza.
// #declare MPBA_Pieza4   
//      Corresponde a las patas.
// #declare MPBA_Pieza5   
//      Corresponde al cuerpo principal eje de la estructura.
// #declare MPBA_Pieza6   
//      Corresponde a la juntura para las patas.
// #declare MPBA_Pieza7   
//      Corresponde a la juntura para la cabeza.
// #declare MPBA_Pieza8   
//      Corresponde a la juntura para las alas.
// #declare MPBA_TransformPieza4A          
//      Transform adicional para ubicar la pata delantera.
// #declare MPBA_TransformPieza4B
//      Transform adicional para ubicar la pata media.
// #declare MPBA_TransformPieza4C          
//      Transform adicional para ubicar la pata posterior.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default).
// Debera ubicar los modificadores antes de la primera inclusion del archivo.   
// #declare MPBA_Ojito                     = object { ... }  
//      Define el objeto para el ojo. Considere un hermisferio de
//      diametro unitario orientado en sentido Z-.  
// #declare MPBA_MaterialPrincipal         =
//                  material { MPBA_DefaultMaterialPrincipal }
//      Material principal a aplicar al objeto.
// #declare MPBA_MaterialAlas              =
//                  material { MPBA_DefaultMaterialAlas }
//      Material para las alas.
// #declare MPBA_MaterialPatas             =
//                  material { MPBA_DefaultMaterialPatas }
//      Material para aplicar a las patas.
//        
// Para colocarlo simplemente
// #include "MPBA.inc" 
// object { MPBA_Mariposa() }
//                                 
// Con modificadores
// #include "textures.inc"
// #declare MPBA_MaterialPrincipal   = material { textures { PinkAlabaster } }
// #include "MPBA.inc"
// object        { MPBA_Mariposa() }
//
#include "MPBA_AU1.inc"  
#include "textures.inc"

#declare MPBA_L                         = 0.001;   

#if ( version < 3.2 )
  #ifndef( MPBA_POV3_1 )
    #declare MPBA_POV3_1        = on;
  #end
#else
  #ifndef( MPBA_POV3_1 )
    #declare MPBA_POV3_1        = off;
  #end
#end

#declare MPBA_DefaultMaterialPrincipal  =
  material                              {
    #if ( MPBA_POV3_1 )
      texture                           {
        pigment { Green transmit 0.8 }
      }
    #else  // #else ( MPBA_POV3_1 )
      M_NB_Winebottle_Glass
    #end   // #else ( MPBA_POV3_1 )
  }        
  
#ifndef ( MPBA_MaterialPrincipal )        
  #declare MPBA_MaterialPrincipal       = MPBA_DefaultMaterialPrincipal
#end  // #ifndef ( MPBA_MaterialPrincipal )  
       
#declare MPBA_DefaultMaterialAlas       =
  material                              {  
    #if ( MPBA_POV3_1 )
      texture                           {
        pigment { Green transmit 0.8 }
      }
    #else  // #else ( MPBA_POV3_1 )
      M_NB_Winebottle_Glass
    #end   // #else ( MPBA_POV3_1 )
  }        
  
#ifndef ( MPBA_MaterialAlas )        
  #declare MPBA_MaterialAlas            = MPBA_DefaultMaterialAlas
#end  // #ifndef ( MPBA_MaterialAlas )  

#declare MPBA_DefaultMaterialPatas      =
  material                              {  
    #if ( MPBA_POV3_1 )
      texture                           {
        pigment { Green transmit 0.8 }
      }
    #else  // #else ( MPBA_POV3_1 )
      M_NB_Winebottle_Glass
    #end   // #else ( MPBA_POV3_1 )
  }        
  
#ifndef ( MPBA_MaterialPatas )        
  #declare MPBA_MaterialPatas           = MPBA_DefaultMaterialPatas
#end  // #ifndef ( MPBA_MaterialPatas )  

       
#declare MPBA_EpsplineAjusteInicial     = MPBA_19_NORMAL_TRANSFORM
#declare MPBA_EscaleFinal               = < 112.6, 112.6, 0.7 >*MPBA_L;
#declare MPBA_TransformComun            =
  transform                             {
    MPBA_EpsplineAjusteInicial
    rotate              -90*x
    scale       MPBA_EscaleFinal
  }

#declare MPBA_Pieza1_CentroInicial      =
  < MPBA_19_right+MPBA_19_left, 0, MPBA_19_top+MPBA_19_bottom >/2;

#declare MPBA_Pieza1                    =
  difference                            {
    object { MPBA_19 }
    object { MPBA_20 }
    object { MPBA_21 }
    object { MPBA_22 }
    object { MPBA_23 }
    object { MPBA_24 }
    object { MPBA_25 }
    object { MPBA_26 }
    object { MPBA_27 }
    object { MPBA_28 }
    object { MPBA_29 }
    object { MPBA_30 }
    transform   MPBA_TransformComun
    translate           ( -41.0*x-34.5*y )*MPBA_L-MPBA_EscaleFinal.z*z
    rotate                       90*x
    rotate                       237*z
    material                           {
      MPBA_MaterialAlas
    }
    translate                    ( +6.5*x+12.5*y )*MPBA_L
    rotate                              90*y
    rotate                              -13.0*z
    translate                   ( -6.75*x+6.75*y )*MPBA_L
    translate  18.5*MPBA_L*y                       
  }

#declare MPBA_Pieza2_CentroInicial      =
  < MPBA_6_right+MPBA_6_left, 0, MPBA_6_top+MPBA_6_bottom >/2;

#declare MPBA_Pieza2                    =
  difference                            {
    object { MPBA_6  }
    object { MPBA_7  }
    object { MPBA_8  }
    object { MPBA_9  }
    object { MPBA_10 }
    object { MPBA_11 }
    object { MPBA_12 }
    object { MPBA_13 }
    object { MPBA_14 }
    object { MPBA_15 }
    object { MPBA_16 }
    object { MPBA_17 }
    object { MPBA_18 }
    translate   -MPBA_Pieza2_CentroInicial+MPBA_Pieza1_CentroInicial
    transform   MPBA_TransformComun
    translate           ( +20.5*x-48.3*y )*MPBA_L+MPBA_EscaleFinal.z*z
    rotate              180*z
    rotate                       90*x
    rotate                       237*z
    material                           {
      MPBA_MaterialAlas
    }
    translate                    ( +6.5*x+12.5*y )*MPBA_L
    rotate                              90*y
    rotate                              -13.0*z
    translate                   ( -6.75*x+6.75*y )*MPBA_L
    translate  18.5*MPBA_L*y                       
  }
                     
#ifndef ( MPBA_Ojito )                     
  #declare MPBA_Ojito                     =
    union                                 {
      cylinder                            {
        0, -0.05*z, 0.5
        pigment { White }
      }
      difference                          {
        sphere                            {
          0, 0.475
        }
        plane                             {
          -z, 0
        }
        pigment { color White transmit 0.8 }
        translate                 -0.045*z
      }
      cylinder                            {
        0, -0.1*z, 0.25
        rotate            10
        translate         -0.175*y-0.10*z
        pigment { Black }
      }    
    }           
#end  // #ifndef ( MPBA_Ojito )

#declare MPBA_Pieza3_CentroInicial      =
  < MPBA_5_right+MPBA_5_left, 0, MPBA_5_top+MPBA_5_bottom >/2;

#declare MPBA_Pieza3                    =
  union                                 {
    object                              {
      MPBA_5
      translate   -MPBA_Pieza3_CentroInicial+MPBA_Pieza1_CentroInicial
      transform   MPBA_TransformComun
      translate                   ( +11.5*x-34.0*y )*MPBA_L
      rotate                              213*z
    }
    object                              {
      MPBA_Ojito
      scale             5*MPBA_L
      translate                 ( -7.5*x+5.0*y )*MPBA_L
      translate         -MPBA_EscaleFinal.z*z
    }
    rotate                             -5*x
    translate                        ( 7.0*y-6.5*z )*MPBA_L
    rotate                      -13*z
    translate                   ( -24.75*x+5.5*y )*MPBA_L
    translate  18.5*MPBA_L*y                       
    material                           {
      MPBA_MaterialPrincipal
    }
  }

#declare MPBA_Pieza4_CentroInicial      =
  < MPBA_4_right+MPBA_4_left, 0, MPBA_4_top+MPBA_4_bottom >/2;
     
#declare MPBA_TransformPieza4A          =
         transform                      {           
           rotate                       45*z
           translate                    ( +6.0*x+3.0*y )*MPBA_L
           rotate                      90*y
           rotate                      90*z
           translate  18.5*MPBA_L*y      
         }                   
        
#declare MPBA_TransformPieza4B          =
         transform                      {           
           rotate                      -40*z
           translate                   ( +11.0*x-6.0*y )*MPBA_L
           rotate                      90*y
           rotate                      90*z
           translate  18.5*MPBA_L*y      
         }                   
           
#declare MPBA_TransformPieza4C          =
         transform                      {
           rotate                      -50*z
           translate                   ( +6.0*x-13.0*y )*MPBA_L
           rotate                      90*y
           rotate                      90*z
           translate  18.5*MPBA_L*y     
         }                    
           
#declare MPBA_Pieza4                    =
  object                                {
    MPBA_4
    translate   -MPBA_Pieza4_CentroInicial+MPBA_Pieza1_CentroInicial
    transform   MPBA_TransformComun
    translate                   ( +15.0*x-2.0*y )*MPBA_L
    rotate                             90*x       
    material                            {
      MPBA_MaterialPatas
    }
  }

#declare MPBA_Pieza5_CentroInicial      =
  < MPBA_3_right+MPBA_3_left, 0, MPBA_3_top+MPBA_3_bottom >/2;

#declare MPBA_Pieza5                    =
  object                                {
    MPBA_3
    translate   -MPBA_Pieza5_CentroInicial+MPBA_Pieza1_CentroInicial
    transform   MPBA_TransformComun
    scale                       <-1,1,1>
    rotate                             -100*z
    translate                           ( 4.5*x+3.0*y )*MPBA_L 
    translate  18.5*MPBA_L*y                       
    material                           {
      MPBA_MaterialPrincipal
    }
  }

#declare MPBA_Pieza6_CentroInicial      =
  < MPBA_2_right+MPBA_2_left, 0, MPBA_2_top+MPBA_2_bottom >/2;

#declare MPBA_Pieza6                    =
  object                                {
    MPBA_2
    translate   -MPBA_Pieza6_CentroInicial+MPBA_Pieza1_CentroInicial
    transform   MPBA_TransformComun
    translate   ( 0.5*x-4.0*y )*MPBA_L
    rotate                      90*y
    rotate                      90*z 
    translate  18.5*MPBA_L*y                       
    material                           {
      MPBA_MaterialPrincipal
    }
  }

#declare MPBA_Pieza7_CentroInicial      =
  < MPBA_1_right+MPBA_1_left, 0, MPBA_1_top+MPBA_1_bottom >/2;

#declare MPBA_Pieza7                    =
  object                                {
    MPBA_1
    translate   -MPBA_Pieza7_CentroInicial+MPBA_Pieza1_CentroInicial
    transform   MPBA_TransformComun
    translate                   ( -0.5*x-6.5*y )*MPBA_L
    rotate                      90*y
    scale                               <1,-1,1>
    rotate                      -13*z
    translate                   ( -24.75*x+5.5*y )*MPBA_L
    translate  18.5*MPBA_L*y                       
    material                           {
      MPBA_MaterialPrincipal
    }
  }

#declare MPBA_Pieza8_CentroInicial      =
  < MPBA_0_right+MPBA_0_left, 0, MPBA_0_top+MPBA_0_bottom >/2;

#declare MPBA_Pieza8                    =
  object                                {
    MPBA_0
    translate   -MPBA_Pieza8_CentroInicial+MPBA_Pieza1_CentroInicial
    transform   MPBA_TransformComun
    translate                   ( -0.8*x-8*y )*MPBA_L
    scale                       <1,-1,1>
    rotate                              90*y
    rotate                              -13.0*z
    translate                   ( -6.75*x+6.75*y )*MPBA_L
    translate  18.5*MPBA_L*y                       
    material                           {
      MPBA_MaterialPrincipal
    }
  }

#macro MPBA_Mariposa()
   merge                                {
     object                             {
       MPBA_Pieza5
     }
     object                             {
       MPBA_Pieza6
     }
     object                             {
       MPBA_Pieza7
     }
     object                             {
       MPBA_Pieza8
     }
     #local C                           = 0;
     #while ( C < 2 )
       merge                            {
         object                         {
           MPBA_Pieza4   
           transform      MPBA_TransformPieza4A
         }
         object                         {
           MPBA_Pieza4   
           transform      MPBA_TransformPieza4B
         }
         object                         {
           MPBA_Pieza4   
           transform      MPBA_TransformPieza4C
         }
         object                         {
           MPBA_Pieza3
         }
         merge                          {
           object                       {
             MPBA_Pieza1
           }
           object                       {
             MPBA_Pieza2
           }                 
         }
         #if ( C = 1 )
           scale                        < 1, 1, -1 >
         #end  // #if ( C = 1 )
       }
       #local C                         = C+1;     
     #end  // #while ( C < 2 )  
     material                           {
       MPBA_MaterialPrincipal
     }
   }
#end  // #macro MPBA_Mariposa
