// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 24 enero 2017
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//      
// MPBA MariposaPlasticoBrillanteArtificial
// Un rompecabezas tridimensional en forma de mariposa (el original brilla en
// la oscuridad). Es muy poco flexible, pero se puede modificar los materiales,
// y las piezas pueden dibujarse en forma individual. 
// Es compatible con POV-Ray 3.1. 
//
// Un alto porcentaje del modelo fue disenado mediante 
// la herramienta Epspline.exe, para prismas. 
// El interesado puede conseguir el programa Epspline.exe en 
// http://agalena.nfshost.com/b1/ 
//
// La macro principal no tiene parametros.   
// #macro Mariposa()
//
// La mariposa se encuentra completamente contenida en:   
//      Punto Minimo    = < - 80,    0, - 48 >*L
//      Punto Maximo    = < +103, +130, + 48 >*L 
// La mariposa mira hacia X- gravedad Y-. Descansa directamente sobre
// el plano XZ. Es completamente simetrica respecto al plano XY.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente. 
// Excepto por MPBA_Pieza4, las piezas se ubican en su lugar correcto.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare MPBA_DefaultMaterialPrincipal       
//      Material principal a aplicar al objeto.
// #declare MPBA_DefaultMaterialAlas          
//      Material para las alas.
// #declare MPBA_DefaultMaterialPatas           
//      Material para aplicar a las patas.
// #declare MPBA_Pieza1   
//      Corresponde a las alas grandes.
// #declare MPBA_Pieza2
//      Corresponde a las alas pequenas.
// #declare MPBA_Pieza3   
//      Corresponde a las antenas y cabeza.
// #declare MPBA_Pieza4   
//      Corresponde a las patas.
// #declare MPBA_Pieza5   
//      Corresponde al cuerpo principal eje de la estructura.
// #declare MPBA_Pieza6   
//      Corresponde a la juntura para las patas.
// #declare MPBA_Pieza7   
//      Corresponde a la juntura para la cabeza.
// #declare MPBA_Pieza8   
//      Corresponde a la juntura para las alas.
// #declare MPBA_TransformPieza4A          
//      Transform adicional para ubicar la pata delantera.
// #declare MPBA_TransformPieza4B
//      Transform adicional para ubicar la pata media.
// #declare MPBA_TransformPieza4C          
//      Transform adicional para ubicar la pata posterior.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default).
// Debera ubicar los modificadores antes de la primera inclusion del archivo.   
// #declare MPBA_Ojito                     = object { ... }  
//      Define el objeto para el ojo. Considere un hermisferio de
//      diametro unitario orientado en sentido Z-.  
// #declare MPBA_MaterialPrincipal         =
//                  material { MPBA_DefaultMaterialPrincipal }
//      Material principal a aplicar al objeto.
// #declare MPBA_MaterialAlas              =
//                  material { MPBA_DefaultMaterialAlas }
//      Material para las alas.
// #declare MPBA_MaterialPatas             =
//                  material { MPBA_DefaultMaterialPatas }
//      Material para aplicar a las patas.
//        
// Para colocarlo simplemente
// #include "MPBA.inc" 
// object { MPBA_Mariposa() }
//                                 
// Con modificadores
// #include "textures.inc"
// #declare MPBA_MaterialPrincipal   = material { textures { PinkAlabaster } }
// #include "MPBA.inc"
// object        { MPBA_Mariposa() }
//
#if ( version >= 3.7 )
  #version 3.7; 
#end

global_settings { assumed_gamma 1.0 max_trace_level 10 }


#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}

background      {
         Gray50
}

#include "MPBA.inc"

#local FactorAcercamiento       = 8;                                   
                                   
object                                  {
  MPBA_Mariposa()                
  translate             -0.065*y-0.010*x
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z      
}
