// This file is licensed under the terms of the CC-LGPL.
//    
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...       
// La imagen corresponde a un juego comercial de mi autoria
// puede encontrarlo en el sitio www.juegosenlazaruscostarricenses.com
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 28 diciembre de 2016
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// RTSP RompecabezasTodasSusPies
// El archivo dibuja un rompecabezas de tamano e imagen variable, sus
// piezas pueden ser ubicadas a gusto del usuario, por defecto
// se dibujan con todas las piezas en su lugar. 
// Es muy poco flexible. Es compatible con POVRay 3.1.
// 
// El proceso de dibujo requiere llamar a dos macros, una primera de inicializacion
// y luego el dibujo propiamente dicho. Se separo en dos etapas para permitir
// que el usuario realice algunos cambios antes del dibujo final.
// La macro de inicializacion tiene cuatro parametros. 
// #macro RTSP_InicializarRompecabezas
//              ( NombreImagen, VectorContenedor,
//                DensidadPiezas, FactorCorte )   
//      NombreImagen            : Archivo de imagen "GIF" que contiene la imagen
//              a dibujar en el rompecabezas.
//      VectorContenedor        : El rompecabezas estara contenido en un prisma
//              rectangular centrado en el origen con estas dimensiones.
//              Ademas se le agregara una ligera perturbacion aleatoria.
//              Interprete como <AnchoImagen,AltoImagen,GruesoCarton>.
//              La imagen mira en direccion Z-.
//      DensidadPiezas          : Fraccion propia para numero de piezas. Utilice
//              0.0 para dos piezas en la dimension menor y 1.0 para unas
//              treinta piezas en la dimension mayor.
//      FactorCorte             : Fraccion propia para aumentar la separacion
//              entre imagenes sucesivas con un fondo de textura base. 
//              Esto es un efecto "artificial", pero resulta
//              util para percibir la separacion de las piezas.
//                                                            
// Una vez inicializado puede modificar la posicion de las piezas, con los
// modificadores RTSP_GiroPiezas y RTSP_PosicionPiezas. 
// Luego se procede a solicitar una de las dos macros de dibujo. La siguiente macro dibuja
// todas las piezas.   
// #macro RTSP_RompecabezasTodasSusPiezas()  
//
// Esta otra macro dibuja una unica pieza.
// #macro RTSP_RompecabezasUnaPieza( C, D, BanderaUbicar )
//      C                       : Posicion Fila de la pieza de abajo hacia arriba
//              a partir de cero.
//      D                       : Posicion Columna de la pieza de izquierda a derecha
//              a partir de cero.                       
//      BanderaUbicar           : "off" ubica la pieza casi centrada en el origen
//              sin desplazamientos ni efectos aleatorios de posicion.
//              Utilice "on" para dibujar la pieza en posicion, determinada por los
//              arreglos de ubicacion y parametros de perturbacion.
//
// El rompecabezas de juego se encuentra contenido en un box centrado en el origen
// de dimensiones dadas por el parametro VectorContenedor.
// La imagen mira en direccion Z-, y la parte inferior de la imagen apunta hacia Y-.
//
// Estas son variables predefinidas o generadas en el
// interna de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare RTSP_DefaultTexturaInferior
//      Textura por defecto para la base de carton del rompecabezas.
// #declare RTSP_Filas                
//      Total de filas del rompecabezas luego de la inicialzacion.
// #declare RTSP_Columnas                  
//      Total de columnas del rompecabezas luego de la inicializacion.   
// #declare RTSP_Aleatorio                  = array[2*RTSP_Filas+1][2*RTSP_Columnas+1]  
//      Array bidimensional de los valores aleatorios que se utilizara en el diseno del
//      rompecabezas. Se genera en la inicializacion.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default).
// Para asegurarse que tengan efecto conviene redefinirlos
// antes de la inicializacion, y luego de la inclusion del archivo. 
// RTSP_GiroPiezas y RTSP_PosicionPiezas se generan en el interior de la macro,
// y deberan modificarse posterior a la inicializacion.  
// #declare RTSP_GiroPiezas                 = array[RTSP_Filas][RTSP_Columnas]   
//      La macro de inicializacion genera este arreglo como vectores 3D
//      completamente nulos. No incluye los pequenos efectos de perturbacion
//      aleatorio que se agregan despues. El usuario puede modificarla
//      para agregar el giro que desee, que se aplica antes de trasladar.
// #declare RTSP_PosicionPiezas             = array[RTSP_Filas][RTSP_Columnas]
//      La macro de inicializacion genera este arreglo con las posiciones 3D
//      que ubican al rompecabezas en posicion armada. Puede modificar a combiniencia.
//      Si las modificaciones son muchas, probablemente sea mejor dibujar las
//      piezas individualmente.
// #declare RTSP_PerturbacionAngular        = 2;
//      Angulo de perturbacion (se multiplica por una variable aleatoria),
//      para ubicar las piezas. Puede utilizar 0.0 para ningun efecto. 
//      Es admisible utilizar un Vector 3D.
// #declare RTSP_PerturbacionPosicion       = 0.05;
//      Fraccion propia para intensidad de perturbacion de la posicion de las piezas
//      en su lugar. Esta perturbacion aplica en dos dimensiones.
// #declare RTSP_PerturbacionEsquina        = 0.2;
//      Fraccion propia para intensidad de desplazamiento en las esquinas de forma aleatoria. 
//      Para piezas de forma homogenea deberia anular este y RTSP_FactorDesplazarInterior.
// #declare RTSP_FactorDesplazarInterior    = 0.1;
//      Fraccion propia para intensidad de desplazamiento de los centros de las muescas
//      de agarre de las piezas. 
//      Para piezas de forma homogenea deberia anular este y RTSP_PerturbacionEsquina.
// #declare RTSP_FactorPerturbacionTexturaInferior      = 0.1;
//      Fraccion propia para perturbar la textura inferior de la base
//      con el objetivo que resulte mas simple percibir
//      las piezas en la vista posterior del rompecabezas. Utilice 0.0 para textura
//      homogenea.
// #declare RTSP_FactorCizalla              = 0.05;
//      Fraccion propia pequena para agregar una cizalla a los bordes de imagen,
//      lo que puede aumentar su brillo caracteristico en los bordes.
// #declare RTSP_FactorPapel                = 0.05;
//      Fraccion propia del tamano del papel relativo al grueso Z del rompecabezas.
// #declare RTSP_FactorCorteInferior        = -0.75;
//      Fraccion relativa al Corte Superior. Mide la separacion entre piezas adyacentes.
//      Un valor negativo sirve para eliminar espacios vacios que surgen por la aleatoriedad,
//      pero puede ser positivo o cero.  
// #declare RTSP_DefaultSemilla             = 2100;
//      Valor semilla que se utilizara para generar los efectos aleatorios. Tomar en cuenta
//      que afecta unicamente la inicializacion, luego ya no se volvera a llamar
//      al generador de numeros aleatorios.  
// #declare RTSP_AplicarNormalImagen        = on;
//      "on" aplica RTSP_NormalImagen a la textura de imagen impresa, "off" lo desactiva. 
// #declare RTSP_NormalImagen               = normal { ... } 
//      Normal a aplicar a la textura de imagen si activa.
// #declare RTSP_AplicarFinishImagen        = on;
//      "on" aplica RTSP_FinishImagen a la textura de imagen impresa, "off" lo desactiva.
// #declare RTSP_FinishImagen               = finish { ... }
//      Finish a aplicar a la textura de imagen si activa.
// #declare RTSP_TexturaSobre               = texture { pigment { rgbt 1.0 } }
//      Textura que se aplica en capa sobre la textura de imagen. Por defecto es una
//      capa transparente. Puede ser util para envejecer u otros efectos similares.
// #declare RTSP_TexturaInferior            = texture { RTSP_DefaultTexturaInferior }
//      Textura inferior a aplicar a la base del rompecabezas. En la inicializacion
//      la textura se corrige aplicando el tamano de imagen.   
//        
// Para colocarlo se llama las dos macros en sucesion
// #include "RTSP.inc"    
// RTSP_InicializarRompecabezas( "RTSP_IM1.gif", <0.240,0.180,0.001>, 0.15, 0.50 )
// object { RTSP_RompecabezasTodasSysPiezas() }
//                                  
// Ejemplo con modificadores
// #include "RTSP.inc"                                 
// #include "textures.inc"
// #declare RTSP_TexturaInferior        = PinkAlabaster
// RTSP_InicializarRompecabezas( "RTSP_IM1.gif", <0.240,0.180,0.001>, 0.15, 0.50 )   
// #declare RTSP_GiroPiezas[0][0]       = 45;
// object { RTSP_RompecabezasTodasSysPiezas() }
//
// Podemos dibujar una sola pieza sin movimiento adicional        
// #include "RTSP.inc"    
// RTSP_InicializarRompecabezas( "RTSP_IM1.gif", <0.240,0.180,0.001>, 0.15, 0.50 )
// object { RTSP_RompecabezasUnaPieza(0,0,false) }
// 
#if ( version >= 3.7 )
  #version 3.7; 
#end

global_settings { assumed_gamma 1.0 }

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "RTSP.inc"

#local FactorAcercamiento       = 6;                                   

RTSP_InicializarRompecabezas( "RTSP_IM1.gif", <0.240,0.180,0.001>, 0.15, 0.50 )
#declare RTSP_PosicionPiezas[2][1]    =
  RTSP_PosicionPiezas[2][1]+0.220*x+0.07*y;
#declare RTSP_GiroPiezas[2][1]        = 30*z;
#declare RTSP_PosicionPiezas[5][3]    =
  RTSP_PosicionPiezas[5][3]+0.160*x-0.10*y;
#declare RTSP_GiroPiezas[5][3]        = -70*z;
#declare RTSP_PosicionPiezas[1][6]    =
  RTSP_PosicionPiezas[1][6]+0.075*x+0.15*y;

object                          { 
  RTSP_RompecabezasTodasSusPiezas()  
  translate       -0.020*x-0.010*y
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z      
}
