// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 13 julio 2016
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// SCPA SierraCortanteParaAdultos
// El archivo dibuja una sierra de mano para uso domstico.
// Es muy poco flexible. Es compatible con POVRay 3.1.
//
// La macro principal no tiene parametros. 
// #macro SCPA_Sierra( ) 
//                                               
// La siguiente macro permite mayor flexibilidad de las caracteristicas.
// #macro SCPA_SierraCortanteParaAdultos( LargoBase, AltoBase, GruesoBase,
//                  LargoAdicional, AltoSierra, GruesoSierra, LargoMango,
//                  MaterialPrincipal, MaterialFilo,
//                  MaterialAgarre, MaterialTornillo, MaterialMango )
//      LargoBase               : Largo referencia X para el cuerpo principal de la sierra.
//              Valor por defecto 138.0*L.
//      AltoBase                : Alto referencia Y para el soporte principal del aparato.
//              Valor por defecto 19.5*L.
//      GruesoBase              : Grueso referencia Z para el soporte de la sierra.
//              Valor por defecto 7.5*L.
//      LargoAdicional          : Largo extra para el dibujo de la sierra completa.
//              Valor por defecto 125.0*L.
//      AltoSierra              : Alto extra para ubicar la sierra.
//              Valor por defecto 50.0*L.
//      GruesoSierra            : Grueso referencia Z para la sierra. Valor por defecto 0.5*L.
//      LargoMango              : Largo del mango para el cuerpo de la sierra.
//              Valor por defecto 32.0*L.
//      MaterialPrincipal       : Material principal para el aparato. 
//              Valor por defecto SCPA_MaterialPrincipal.
//      MaterialFilo            : Material del filo de la sierra.
//              Valor por defecto SCPA_MaterialFilo.
//      MaterialAgarre          : Material para el soporte metalico del aparato.
//              Valor por defecto SCPA_MaterialAgarre.
//      MaterialTornillo        : Material para los tornillos.
//              Valor por defecto SCPA_MaterialTornillo.
//      MaterialMango           : Material para el mango de la sierra.
//              Valor por defecto SCPA_MaterialMango.
//      
// La sierra se encuentra completamente contenida dentro de las siguientes coordenadas.
//      Minimo  = < -54, -68,  -8 >*L
//      Maximo  = < 265,   1,   8 >*L  
// Frente mira hacia X+, gravedad Y-. El origen se ubica casi en el borde superior
// de la unin entre el mango y la sierra.
//
// Estas son variables predefinidas o generadas en el
// interna de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare SCPA_DefaultMaterialPrincipal  
//      Material principal para el aparato.
// #declare SCPA_DefaultMaterialFilo      
//      Material del filo de la sierra.
// #declare SCPA_DefaultMaterialAgarre
//      Material para el soporte metalico del aparato.
// #declare SCPA_DefaultMaterialTornillo
//      Material para los tornillos.
// #declare SCPA_DefaultMaterialMango
//      Material para el mango de la sierra.           
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare SCPA_MaterialPrincipal              = material { ... }                 
//      Material principal para el aparato.
// #declare SCPA_MaterialFilo                   = material { ... }
//      Material del filo de la sierra.                                   
// #declare SCPA_MaterialAgarre                 = material { ... }
//      Material para el soporte metalico del aparato.
// #declare SCPA_MaterialTornillo               = material { ... }
//      Material para los tornillos.
// #declare SCPA_MaterialMango                  = material { ... }
//      Material para el mango de la sierra.
//        
// Para colocarlo simplemente
// #include "SCPA.inc" 
// object { SCPA_Sierra( ) }
//                                  
// Ejemplo con la macro detallada, mismo objeto default
// #include "SCPA.inc"   
// object                       {
//   SCPA_SierraCortanteParaAdultos(0.138,0.0195,0.0075,0.125,0.050,0.0005,0.032,
//      SCPA_MaterialPrincipal, SCPA_MaterialFilo,
//      SCPA_MaterialAgarre, SCPA_MaterialTornillo, SCPA_MaterialMango)
// }
//        
// Con modificadores
// #include "SCPA.inc"
// #include "textures.inc"
// #declare SCPA_MaterialPrincipal   = material { texture { PinkAlabaster } }
// object        { SCPA_Sierra( ) }
// 
#declare SCPA_L                 = 0.001;

#declare SCPA_DefaultMaterialPrincipal          =
  material                      {
    texture                     {
      pigment               {
        Silver*0.70+GreenCopper*0.30
      }
      normal                {
        bumps
        turbulence          0.05
        scale               0.01
      }
      finish                {
        specular            0.2
        roughness           0.01
        metallic
      }
    }
  }

#ifndef ( SCPA_MaterialPrincipal )
  #declare SCPA_MaterialPrincipal       = SCPA_DefaultMaterialPrincipal
#end  // #ifndef ( SCPA_MaterialPrincipal )

#declare SCPA_DefaultMaterialAgarre        =
  material                      {
    texture                     {
      pigment               {
        Silver*0.50+GreenCopper*0.50
      }
      normal                {
        bumps
        turbulence          0.05
        scale               0.01
      }
      finish                {
        specular            0.2
        roughness           0.01
        metallic
      }
    }
  }

#ifndef ( SCPA_MaterialAgarre )
  #declare SCPA_MaterialAgarre            = SCPA_DefaultMaterialAgarre
#end  // #ifndef ( SCPA_MaterialAgarre )

#declare SCPA_DefaultMaterialFilo          =
  material                      {
    texture                     {
      pigment               {
        Silver*0.90+GreenCopper*0.10
      }
      normal                {
        bumps
        turbulence          0.05
        scale               0.01
      }
      finish                {
        specular            0.2
        roughness           0.01
        metallic
      }
    }
  }

#ifndef ( SCPA_MaterialFilo )
  #declare SCPA_MaterialFilo            = SCPA_DefaultMaterialFilo
#end  // #ifndef ( SCPA_MaterialFilo )

#declare SCPA_DefaultMaterialTornillo      =
  material                      {
    texture                     {
      pigment               {
        Silver*0.20+GreenCopper*0.80
      }
      normal                {
        bumps
        turbulence          0.05
        scale               0.01
      }
      finish                {
        specular            0.2
        roughness           0.01
        metallic
      }
    }
  }

#ifndef ( SCPA_MaterialTornillo )
  #declare SCPA_MaterialTornillo          = SCPA_DefaultMaterialTornillo
#end  // #ifndef ( SCPA_MaterialTornillo )

#declare SCPA_DefaultMaterialMango        =
  material                      {
    texture                     {
      pigment               {
        Silver*0.20+GreenCopper*0.80
      }
      normal                {
        bumps
        turbulence          0.05
        scale               0.01
      }
      finish                {
        specular            0.2
        roughness           0.01
        metallic
      }
    }
  }

#ifndef ( SCPA_MaterialMango )
  #declare SCPA_MaterialMango             = SCPA_DefaultMaterialMango
#end  // #ifndef ( SCPA_MaterialMango )

#macro SCPA_SierraCortanteParaAdultos(
                LargoBase, AltoBase, GruesoBase,
                LargoAdicional, AltoSierra, GruesoSierra, LargoMango,
                MaterialPrincipal, MaterialFilo,
                MaterialAgarre, MaterialTornillo, MaterialMango )
  union                                 {
    #local Curvatura                    = 5/8*AltoSierra;
    // Curvatura aplica a la curva frontal de la sierra
    #local GruesoExtensible             = 0.5*GruesoBase;
    #local AnchoSierra                  = 0.15*AltoSierra;
    
    // i SoportePrincipal
    union                               {
      intersection                      {
        prism                           {
          -1, 1, 9,
          <0,0>,
          <0.95,0>,
          <1,-1>,
          <0.9,-1>,
          <0.875,-0.8>,
          <0.5,-1>,
          <0.125,-0.8>,
          <0.1,-1>,
          <0,-1>
          rotate                        -90*x
        }
        difference                      {
          superellipsoid                {
            <1,0.05>
            rotate                      90*x
            translate                   -y
            scale                       <1.1,1,0.5>
          }
          superellipsoid                {
            <1,0.05>
            rotate                      90*x
            scale                       <1.1,0.9,0.35>
            translate                   -y
          }
          plane                         {
            x, 0
          }
          plane                         {
            -x, 0
            translate                   x
          }
          plane                         {
            y, 0
            translate                   -y
          }
        }
        scale                     < LargoBase, AltoBase, GruesoBase >
      }
      union                             {
        cylinder                        {
          -0.6*GruesoBase*z, +0.6*GruesoBase*z, 0.10*AltoBase
          translate     <0.05*LargoBase,-0.8*AltoBase,0>
        }
        cylinder                        {
          -0.6*GruesoBase*z, +0.6*GruesoBase*z, 0.10*AltoBase
          translate     <0.95*LargoBase,-0.8*AltoBase,0>
        }
        material                        {
          MaterialTornillo
        }
      }
    }
    // f SoportePrincipal
    // i CurvaturaExtensible
    union                               {
      #local LargoExtensible            = LargoAdicional+0.2*LargoBase;
      cylinder                          {
        ( LargoAdicional-LargoExtensible )*x,
        ( LargoAdicional-Curvatura )*x,
        GruesoExtensible/2
      }
      box                               {
        < LargoAdicional-LargoExtensible, 0, -GruesoExtensible/2 >,
        < LargoAdicional-Curvatura, -0.5*AltoBase, GruesoExtensible/2 >
      }
      cylinder                          {
        ( LargoAdicional-LargoExtensible )*x,
        ( LargoAdicional-Curvatura )*x,
        GruesoExtensible/2
        translate               -0.5*AltoBase*y
      }
      difference                        {
        union                           {
          torus                         {
            Curvatura-GruesoExtensible/2,
            GruesoExtensible/2
            rotate              90*x
          }
          torus                         {
            Curvatura-0.5*AltoBase-GruesoExtensible/2,
            GruesoExtensible/2
            rotate              90*x
          }
          difference                    {
            cylinder                    {
              -GruesoExtensible/2*z, GruesoExtensible/2*z,
              Curvatura-GruesoExtensible/2
            }
            cylinder                    {
              -GruesoExtensible*z, +GruesoExtensible*z,
              Curvatura-GruesoExtensible/2-0.5*AltoBase
            }
          }
        }
        plane                           {
          x, 0
        }
        plane                           {
          y, 0
        }
        translate           -( Curvatura-GruesoExtensible/2 )*y
                                +( LargoAdicional-Curvatura)*x
      }
      union                             {
        cylinder                        {
          0, -( AltoSierra-Curvatura )*y, GruesoExtensible/2
        }
        box                             {
          <-0.5*AltoBase,0,-GruesoExtensible/2>,
          <0,-( AltoSierra-Curvatura ),GruesoExtensible/2>
        }
        cylinder                        {
          0, -( AltoSierra-Curvatura )*y, GruesoExtensible/2
          translate             -0.5*AltoBase*x
        }
        translate           -( Curvatura-GruesoExtensible/2 )*y
                                +( LargoAdicional-GruesoExtensible/2 )*x
      }
      translate         ( -GruesoExtensible/2-0.1*AltoBase )*y
      translate         LargoBase*x
    }
    // f CurvaturaExtensible
    // i Sierra
    union                               {
      #local TotalSierra                =
                        0.8*LargoBase+LargoAdicional-AltoBase;
      union                             {
        cylinder                          {
          -GruesoSierra/2*z, GruesoSierra/2*z, AnchoSierra/2
        }
        box                               {
          <0,AnchoSierra/2,-GruesoSierra/2>,
          <-TotalSierra,-AnchoSierra/2,+GruesoSierra/2>
        }
        cylinder                          {
          -GruesoSierra/2*z, GruesoSierra/2*z, AnchoSierra/2
          translate                       -TotalSierra*x
        }
        material                        {
          MaterialFilo
          scale         < TotalSierra, AnchoSierra, GruesoSierra >
        }
      }
      union                             {
        #local C                        = 0;
        #while ( C < 2 )
          union                         {
            cylinder                        {
              AltoBase*x, 0.3*AltoBase*x, AnchoSierra
            }
            difference                      {
              cylinder                      {
                AltoBase*x, ( -AnchoSierra )*x, AnchoSierra/2
              }
              plane                         {
                z, 0
              }
            }
            cylinder                    {
              0, -AnchoSierra/2*z, AnchoSierra/4
              translate                 -AnchoSierra/2*x
            }
            box                             {
              <0.3*AltoBase,0,-GruesoBase/2>,
              <AltoBase,AnchoSierra+0.3*AltoSierra,+GruesoBase/2>
            }
            cylinder                        {
              -( 1.2*GruesoBase/2 )*z, +( 1.2*GruesoBase/2 )*z,
              AnchoSierra/6
              translate                 +( AnchoSierra+0.15*AltoSierra )*y
                                        +0.5*AltoBase*x
              material { MaterialTornillo }
            }
            cylinder                        {
              -( 1.2*GruesoBase/2 )*z, +( 1.2*GruesoBase/2 )*z,
              AnchoSierra/6
              translate                 +( AnchoSierra+0.15*AltoSierra )*y
                                        +0.5*AltoBase*x
                                        +0.1*AltoBase*( 3*x+y )
              material { MaterialTornillo }
            }
            #if ( C = 0 )
              sphere                            {
                0, 1
                scale                   0.5*<0.2,1,1>*AnchoSierra*2.0
                translate               ( AltoBase+0.1*AnchoSierra )*x
              }
            #else  // #else ( C = 0 )
              union                             {
                cylinder                        {
                  0, 0.7*AltoSierra*y, GruesoExtensible/2
                  translate       ( 0.275*AltoBase+GruesoExtensible/2 )*x
                }
                box                             {
                  <0,0,-GruesoExtensible/2>,
                  <0.5*AltoBase,0.7*AltoSierra,GruesoExtensible/2>
                  translate       ( 0.275*AltoBase+GruesoExtensible/2 )*x
                }
                cylinder                        {
                  0, 0.7*AltoSierra*y, GruesoExtensible/2
                  translate       ( 0.775*AltoBase+GruesoExtensible/2 )*x
                }
                #local FactorDoblar             =
                                (0.2*LargoBase-AltoBase )/( 0.7*AltoSierra );
                matrix          <1,0,0,
                                 FactorDoblar,1,0,
                                 0,0,1,
                                 0,0,0>
                translate           ( AnchoSierra+0.3*AltoSierra )*y
                material                { MaterialPrincipal }
              }
              union                             {
                sphere                            {
                  0, 1
                }
                superellipsoid                    {
                  <0.3,0.3>
                  scale         0.75
                  rotate                60*z
                  translate             0.5*(x+y)
                }
                superellipsoid                    {
                  <0.3,0.3>
                  scale         0.75
                  rotate                60*z
                  translate             0.5*(x-y)
                }
                scale                   0.5*<0.4,1,1>*AnchoSierra*2.0
                translate               ( AltoBase+0.2*AnchoSierra )*x
              }
              scale                             <-1,1,1>
              translate             -( TotalSierra+0.5*AnchoSierra )*x
            #end   // #else ( C = 0 )
            material                        {
              MaterialAgarre
            }
          }
          #local C                      = C+1;
        #end  // #while ( C < 2 )
      }
      translate                 ( LargoBase+LargoAdicional-AltoBase )*x
                                -( AltoSierra+AnchoSierra )*y
    }
    // f Sierra
    // i Mango
    union                               {
      difference                        {
        superellipsoid                  {
          <0.2,0.2>
          matrix     <1,0,0,
                      0.05,1,0,
                      0,0,1,
                      0,0,0>
        }
        plane                           {
          -x,0
        }
        scale                           < LargoMango, 0.5*AltoBase,
                                          1.1*GruesoBase/2 >
        translate                       -0.475*AltoBase*y
      }
      #local FactorMango                = 0.1;
      #local AMango                     = 1;
      #local C                          = 0;
      #while ( C  < 2 )
        difference                      {
          prism                         {
            cubic_spline
            conic_sweep
            1-FactorMango, 1.0, 9,
            <-1.000,-0.000>,
            <-1.700,-1.000>,
            <-1.000,-1.000>,
            <-0.750,-0.300>,
            <-0.500,-0.000>,
            <-1.000,-0.000>,
            <-1.300,-0.400>,
            <-1.700,-1.000>,
            <-1.000,-1.000>
            translate                   -y
            scale                       <1,-1,1>
            rotate                      -90*x
            scale       < LargoMango, AltoSierra, AMango*GruesoBase/FactorMango >
            translate                   -AltoBase/2*y
          }
          #local MaxD                   = 10;
          #local D                      = 0;
          #while ( D < MaxD )
            cylinder                    {
              0, -y, 0.025
              matrix            <1,0,0,
                                 +0.30*AltoSierra/LargoMango,1,0,
                                 0,0,1,
                                 0,0,0>
              scale             <1,1,0.025>
              translate -x-FactorMango*z
              scale       < LargoMango, AltoSierra, AMango*GruesoBase/FactorMango >
              translate                   -AltoBase/2*y
              translate +D*0.7*LargoMango/MaxD*x
            }
            #local D                    = D+1;
          #end  // #while ( D < 1 )
          #if ( C = 1 )
            scale                       <1,1,-1>
          #end  // #if ( C = 1 )
        }
        #local C                        = C+1;
      #end  // #while ( C < 2 )
      material                          {
        MaterialMango
      }
    }
    // f Mango
    material                            {
      MaterialPrincipal
    }
  }
#end  // #macro SCPA_SierraCortanteParaAdultos()

#macro SCPA_Sierra()
  object                                {
    #local L                            = SCPA_L;
    #local LargoBase                    = 138.0*L;
    #local AltoBase                     =  19.5*L;
    #local GruesoBase                   =   7.5*L;
    #local LargoAdicional               = 125.0*L;
    #local AltoSierra                   =  50.0*L;
    #local GruesoSierra                 =   0.5*L;
    #local LargoMango                   =  32.0*L;
    SCPA_SierraCortanteParaAdultos(
      LargoBase, AltoBase, GruesoBase,
      LargoAdicional, AltoSierra, GruesoSierra, LargoMango,
      SCPA_MaterialPrincipal, SCPA_MaterialFilo,
      SCPA_MaterialAgarre, SCPA_MaterialTornillo,
      SCPA_MaterialMango )
  }
#end  // #macro SCPA_Sierra()
